SystemOrganization addCategory: #'SIXX-Squeak'!
SystemOrganization addCategory: #'SIXX-Core'!
SystemOrganization addCategory: #'SIXX-ParserAdapter'!
SystemOrganization addCategory: #'SIXX-Examples'!
SystemOrganization addCategory: #'SIXX-Test'!

!Time class methodsFor: '*sixx-instance creation' stamp: 'mu 1/16/2007 11:28'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^self readSixxContentStringFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!Time class methodsFor: '*sixx-private' stamp: 'mu 1/16/2007 11:28'!
readSixxContentStringFrom: aStream
	"Squeak specific"
	^ self readFrom: aStream! !

!Time methodsFor: '*sixx-printing' stamp: 'MU 9/16/2002 22:29'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxContentString! !

!Time methodsFor: '*sixx-private' stamp: 'MU 9/16/2002 22:28'!
sixxContentString
	"Squeak Specific"
	^self printString! !

!ByteArray class methodsFor: '*sixx-instance creation' stamp: 'mu 6/26/2004 18:36'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| rawStr col |
	rawStr := ReadStream
				on: (SixxXmlUtil characterDataFrom: sixxElement).
	col := rawStr peek = $#
				ifTrue: [Array readFrom: rawStr]
				ifFalse: [self readShortHexFrom: rawStr].
	^ self withAll: col! !

!ByteArray class methodsFor: '*sixx-instance creation' stamp: 'minami 7/14/2004 01:00'!
readShortHexFrom: aStream
	| sz inst |
	sz := aStream size // 2.
	inst := self new: sz.
	1 to: sz do: [:idx | 
		inst at: idx put: (Integer readShortHexFrom: (aStream next: 2) readStream)
	].
	^ inst! !

!ByteArray methodsFor: '*sixx-converting' stamp: 'minami 7/14/2004 00:42'!
shortHexString
	| sz stream |
	sz := self size.
	stream := WriteStream on: (String new: sz * 2).
	1 to: sz do: [:idx | 
		| elem |
		elem := (self at: idx).
		elem < 16 ifTrue: [stream nextPut: $0].
		stream nextPutAll:  elem shortHexString].
	^ stream contents  ! !

!ByteArray methodsFor: '*sixx-printing' stamp: 'minami 7/14/2004 00:43'!
sixxContentOn: aStream indent: level context: dictionary 
	1 to: self size do: [:idx | 
		| elem |
		elem := (self at: idx).
		elem < 16 ifTrue: [aStream nextPut: $0].
		aStream nextPutAll: elem shortHexString].
	! !

!Object methodsFor: '*sixx-private' stamp: 'mu 6/23/2007 19:55'!
basicSixxOn: aStream originator: originator name: nameString indent: level context: dictionary 
	aStream tab: level.
	(dictionary includesKey: originator)
		ifTrue: [aStream
				nextPutAll: (self
						sixxRefTagStartString: (dictionary at: originator) name: nameString)]
		ifFalse: [| idStr | 
			idStr := self sixxReferenceIdInContext: dictionary.			
			dictionary at: originator put: idStr.
			aStream
				nextPutAll: (self sixxTagStartString: idStr name: nameString).
			self
				sixxContentOn: aStream
				indent: level
				context: dictionary].
	aStream nextPutAll: self sixxTagEndString.
	aStream cr! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 6/26/2004 18:05'!
initializeFromSixxElement: sixxElement context: aDictionary 
	self class isBits
		ifTrue: [^ self initializeIndexFieldsFromSixxElement: sixxElement context: aDictionary].
	self class isVariable
		ifTrue: [^ self initializeMixedFieldsFromSixxElement: sixxElement context: aDictionary].
	self initializeInstVarsFromSixxElement: sixxElement context: aDictionary! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 6/25/2004 03:54'!
initializeIndexFieldsFromSixxElement: sixxElement context: aDictionary 
	| idx nonameElems |
	idx := 1.
	nonameElems := (SixxXmlUtil elementsFrom: sixxElement)
				select: [:each | (self class nameFromSixxElement: each) isNil].
	nonameElems isEmpty
		ifFalse: [nonameElems
				do: [:elem | | childInst | (SixxXmlUtil isTextFrom: elem)
						ifFalse: [childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxAt: idx put: childInst.
							idx := idx + 1]]]! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 6/26/2004 18:04'!
initializeInstVarsFromSixxElement: sixxElement context: aDictionary 
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | varName | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [varName := self class nameFromSixxElement: elem.
					varName notNil
						ifTrue: [| childInst | 
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst]]]! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 6/26/2004 18:05'!
initializeMixedFieldsFromSixxElement: sixxElement context: aDictionary 
	self initializeInstVarsFromSixxElement: sixxElement context: aDictionary.
	self initializeIndexFieldsFromSixxElement: sixxElement context: aDictionary ! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 6/25/2004 01:12'!
sixxAt: index put: aValue 
	"override if you like"
	self at: index put: aValue ! !

!Object methodsFor: '*sixx-private' stamp: 'mu 8/21/2007 19:52'!
sixxChildrenContentsOn: aStream indent: level context: dictionary 
	self class isBits
		ifTrue: [aStream nextPutAll: '#( '.
			1 to: self size do: [:idx | 
				aStream nextPutAll: (self at: idx) printString; space
			].
			aStream nextPutAll: ')'.
			^ self].
		
	self class isVariable
		ifTrue: [^ self
				sixxMixedFieldsOn: aStream
				indent: level
				context: dictionary].
			
	self
		sixxInstVarsOn: aStream
		indent: level
		context: dictionary! !

!Object methodsFor: '*sixx-printing' stamp: 'mu 11/29/2006 22:41'!
sixxContentOn: aStream indent: level context: dictionary
	"Override if you like"
	"Typically usable for a customized serialization of the receiver's elements"
	self sixxChildrenContentsOn: aStream indent: level + 1 context: dictionary.
	aStream tab: level.
! !

!Object methodsFor: '*sixx-private' stamp: 'MU 3/6/2003 15:45'!
sixxEnv
	^SixxPortableUtil environmentQualifierOf: self class! !

!Object methodsFor: '*sixx-private' stamp: 'mu 11/29/2006 22:44'!
sixxIgnorableInstVarNames
	"Override if you wish"
	"If you would like to omit some inst vars in serialization, List their names here."

	^#()! !

!Object methodsFor: '*sixx-private' stamp: 'mu 11/10/2006 14:11'!
sixxIndexFieldsOn: aStream indent: level context: dictionary 
	"override if you like"
	| size |
	size := self basicSize.
	size = 0
		ifTrue: [^ self].
	1
		to: size
		do: [:i | 
			| element | 
			element := self basicAt: i.
			element 
				sixxOn: aStream
				indent: level
				context: dictionary]! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 6/24/2004 21:40'!
sixxInitialize
	"override if you like"
	"The method is called after the loading of the receiver - just like #initializaAfterLoad in Envy"
	"It is useful to initializa attributes that cannot be stored in SIXX (Block, Context, etc)"! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 12/21/2006 21:03'!
sixxInstVarNamed: instVarName put: aValue 
	"override if you like"
	"can be used for changing shape"
	| index |
	index _ self class allInstVarNames indexOf: instVarName asString.
	index = 0 ifTrue: [^self].
	self
		instVarAt: index
		put: aValue! !

!Object methodsFor: '*sixx-private' stamp: 'mu 1/15/2007 18:04'!
sixxInstVarNamed: varName value: varValue on: aStream indent: level context: dictionary 
	"override if you wish"
	((self sixxIgnorableInstVarNames collect: [:each | each asString]) includes: varName) ifTrue: [^self].
	varValue 
		sixxOn: aStream
		name: varName
		indent: level
		context: dictionary! !

!Object methodsFor: '*sixx-private' stamp: 'mu 7/20/2006 12:27'!
sixxInstVarsOn: aStream indent: level context: dictionary 
	| instVars ind |
	aStream cr.
	instVars := self class allInstVarNames.
	ind := 0.
	instVars
		do: [:nm | 
			ind := ind + 1.
			self
				sixxInstVarNamed: nm
				value: (self instVarAt: ind)
				on: aStream
				indent: level
				context: dictionary]! !

!Object methodsFor: '*sixx-private' stamp: 'mu 6/26/2004 16:45'!
sixxMixedFieldsOn: aStream indent: level context: dictionary
	self sixxInstVarsOn: aStream indent: level context: dictionary.
	self sixxIndexFieldsOn: aStream indent: level context: dictionary.! !

!Object methodsFor: '*sixx-printing' stamp: 'kuri-t 5/17/2002 14:27'!
sixxOn: aStream 
	self sixxOn: aStream indent: 0 context: IdentityDictionary new! !

!Object methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:35'!
sixxOn: aStream indent: level context: dictionary
	^self sixxOn: aStream name: nil indent: level context: dictionary! !

!Object methodsFor: '*sixx-printing' stamp: 'mu 2/9/2007 10:03'!
sixxOn: aStream name: nameString indent: level context: dictionary 
	self sixxPrepareWrite.
	self sixxWriteValue
		basicSixxOn: aStream
		originator: self
		name: nameString
		indent: level
		context: dictionary! !

!Object methodsFor: '*sixx-private' stamp: 'mu 11/29/2006 22:44'!
sixxPrepareWrite
	"Override if you like"
	"It is used for preparing the receiver's states for serialization "! !

!Object methodsFor: '*sixx-private' stamp: 'mu 11/29/2006 22:42'!
sixxReadValue
	"Override if you wish"
	"It can be useful when memento would like to return real object"

	^self! !

!Object methodsFor: '*sixx-private' stamp: 'mu 6/23/2007 19:56'!
sixxReferenceIdInContext: dictionary
	"override if you would like to generate id by yourself"
	^dictionary size printString! !

!Object methodsFor: '*sixx-private' stamp: 'mu 3/31/2007 19:17'!
sixxRefTagStartString: idString name: nameString 
	| constants |
	constants := SixxConstants current.
	^SixxXmlUtil contentsWithStartTagNamed: constants objectTagName do: [:wStr |   
		SixxXmlUtil writeAttribute: constants idrefTagName value: idString on: wStr.
		SixxXmlUtil writeAttribute: constants nameTagName value: nameString on: wStr.
	]! !

!Object methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:34'!
sixxString
	| wStr |
	wStr := (String new: 128) writeStream.
	self sixxOn: wStr.
	^wStr contents! !

!Object methodsFor: '*sixx-private' stamp: 'mu 3/30/2007 10:35'!
sixxTagEndString
	^SixxXmlUtil contentsWithEndTagNamed: SixxConstants current objectTagName! !

!Object methodsFor: '*sixx-private' stamp: 'mu 4/1/2007 10:35'!
sixxTagStartString: idString name: nameString 
	| constants |
	constants := SixxConstants current.
	^SixxXmlUtil contentsWithStartTagNamed: constants objectTagName do: [:wStr |   
		SixxXmlUtil writeAttribute: constants idTagName value: idString on: wStr.
		SixxXmlUtil writeAttribute: constants nameTagName value: nameString on: wStr.
		SixxXmlUtil writeAttribute: constants typeTagName value: self sixxType on: wStr.
		SixxSettings useEnvironment 
			ifTrue: [SixxXmlUtil writeAttribute: constants envTagName value: self sixxEnv on: wStr.].
	]! !

!Object methodsFor: '*sixx-private' stamp: 'mu 5/10/2002 14:35'!
sixxType
	^self class name! !

!Object methodsFor: '*sixx-private' stamp: 'mu 11/29/2006 22:41'!
sixxWriteValue
	"Override if you wish"
	"It can be useful when you would like to store the receiver in a memento (minimal representation) form."

	^self! !

Object subclass: #SixxClassResolver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

SixxClassResolver class
	instanceVariableNames: 'default'!

!SixxClassResolver class methodsFor: 'accessing' stamp: 'mu 6/6/2007 19:28'!
default
	default ifNil: [default := self new].
	^default! !

!SixxClassResolver class methodsFor: 'accessing' stamp: 'mu 6/6/2007 19:28'!
default: aClassResolver
	default := aClassResolver! !

!SixxClassResolver class methodsFor: 'class initialization' stamp: 'mu 6/6/2007 19:28'!
initialize
	default := nil! !

!SixxClassResolver methodsFor: 'resolving' stamp: 'mu 6/7/2007 21:04'!
classAt: classOrMetaclassName in: environmentQualifier

	| retClass isClassClass className |
	retClass := self shareChangedClassAt: classOrMetaclassName in: environmentQualifier.
	retClass isNil ifFalse: [^retClass].

	isClassClass := false.
	className := (classOrMetaclassName includes: Character space)
				ifTrue: [isClassClass := true.
					classOrMetaclassName readStream upTo: Character space]
				ifFalse: [classOrMetaclassName].

	retClass := SixxPortableUtil classAt: className in: environmentQualifier.
	isClassClass ifTrue: [retClass := retClass class].

	^retClass! !

!SixxClassResolver methodsFor: 'initialize-release' stamp: 'mu 6/6/2007 20:03'!
initialize! !

!SixxClassResolver methodsFor: 'resolving' stamp: 'mu 6/6/2007 20:03'!
shareChangedClassAt: classOrMetaclassName in: environmentQualifier
	"override"
	^nil! !

SixxClassResolver subclass: #SixxShapeChangeClassResolver
	instanceVariableNames: 'shapeChangersDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxShapeChangeClassResolver methodsFor: 'defaults' stamp: 'mu 6/6/2007 20:09'!
defaultEnvironmentQualifier
	^#Smalltalk! !

!SixxShapeChangeClassResolver methodsFor: 'initialize-release' stamp: 'mu 6/6/2007 20:01'!
initialize
	shapeChangersDict := nil! !

!SixxShapeChangeClassResolver methodsFor: 'actions' stamp: 'mu 6/6/2007 20:12'!
putShapeChangers: shapeChangers 
	^self putShapeChangers: shapeChangers in: self defaultEnvironmentQualifier! !

!SixxShapeChangeClassResolver methodsFor: 'actions' stamp: 'mu 6/6/2007 20:15'!
putShapeChangers: shapeChangers in: environmentQualifier
	^self shapeChangersDict at: environmentQualifier put: shapeChangers! !

!SixxShapeChangeClassResolver methodsFor: 'actions' stamp: 'mu 6/6/2007 20:14'!
shapeChangers
	^self shapeChangersIn: self defaultEnvironmentQualifier! !

!SixxShapeChangeClassResolver methodsFor: 'accessing' stamp: 'mu 6/6/2007 20:01'!
shapeChangersDict
	shapeChangersDict isNil ifTrue: [shapeChangersDict := Dictionary new].
	^ shapeChangersDict! !

!SixxShapeChangeClassResolver methodsFor: 'accessing' stamp: 'mu 6/6/2007 20:01'!
shapeChangersDict: anObject
	
	shapeChangersDict := anObject! !

!SixxShapeChangeClassResolver methodsFor: 'actions' stamp: 'mu 6/6/2007 20:14'!
shapeChangersIn: environmentQualifier
	^self shapeChangersDict at: environmentQualifier ifAbsentPut: [Dictionary new].! !

!SixxShapeChangeClassResolver methodsFor: 'resolving' stamp: 'mu 6/6/2007 20:17'!
shareChangedClassAt: classOrMetaclassName in: environmentQualifier

	| envKey shapeChangers shapeChanger |
	envKey := environmentQualifier isNil ifTrue: [self defaultEnvironmentQualifier] ifFalse: [environmentQualifier].
	shapeChangers := self shapeChangersIn: envKey.
	shapeChanger := shapeChangers at: classOrMetaclassName ifAbsent:[].

	^shapeChanger! !

Object subclass: #SixxConstants
	instanceVariableNames: 'xmlVersion xmlEncoding sixxVersion xmlDeclaration'
	classVariableNames: 'ConstantsDetectionMapByRoot ConstantsDetectionMap'
	poolDictionaries: ''
	category: 'SIXX-Core'!

SixxConstants class
	instanceVariableNames: 'current'!

SixxConstants subclass: #SixxCompactConstants
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxCompactConstants methodsFor: 'constants-tag name' stamp: 'mu 3/29/2007 22:59'!
envTagName
	^'e'! !

!SixxCompactConstants methodsFor: 'constants-tag name' stamp: 'mu 3/29/2007 22:53'!
idrefTagName
	^'r'! !

!SixxCompactConstants methodsFor: 'constants-tag name' stamp: 'mu 3/29/2007 22:56'!
idTagName
	^'i'! !

!SixxCompactConstants methodsFor: 'constants-tag name' stamp: 'mu 3/29/2007 22:55'!
nameTagName
	^'n'! !

!SixxCompactConstants methodsFor: 'constants-tag name' stamp: 'mu 3/29/2007 22:53'!
objectTagName
	^'o'! !

!SixxCompactConstants methodsFor: 'constants-tag name' stamp: 'mu 4/1/2007 19:10'!
rootTagName
	^'cixx'! !

!SixxCompactConstants methodsFor: 'constants-tag name' stamp: 'mu 3/29/2007 23:13'!
typeTagName
	^'t'! !

!SixxCompactConstants methodsFor: 'constants-tag name' stamp: 'mu 3/30/2007 10:47'!
versionTagName
	^'v'! !

!SixxConstants class methodsFor: 'accessing' stamp: 'mu 6/23/2007 18:34'!
constantsDetectionMap
	ConstantsDetectionMap isNil ifTrue: [ConstantsDetectionMap := Dictionary new].
	^ConstantsDetectionMap! !

!SixxConstants class methodsFor: 'accessing' stamp: 'mu 6/23/2007 19:14'!
constantsDetectionMapByRoot
	ConstantsDetectionMapByRoot isNil ifTrue: [ConstantsDetectionMapByRoot := Dictionary new].
	^ConstantsDetectionMapByRoot! !

!SixxConstants class methodsFor: 'accessing' stamp: 'mu 3/29/2007 22:44'!
current
	current isNil ifTrue: [current := self new].
	^current! !

!SixxConstants class methodsFor: 'accessing' stamp: 'mu 3/30/2007 10:37'!
current: aSixxConstants
	current := aSixxConstants! !

!SixxConstants class methodsFor: 'class initialization' stamp: 'mu 6/23/2007 19:13'!
initConstantsDetectionMaps
	"SixxConstants initConstantsDetectionMaps"
	ConstantsDetectionMap := nil.
	self registerToDetectionMaps.
	self allSubclasses do: [:each | each registerToDetectionMaps]. 
	! !

!SixxConstants class methodsFor: 'class initialization' stamp: 'mu 6/23/2007 19:05'!
initialize
	"SixxConstants initialize"
	current := nil.
	self initConstantsDetectionMaps
	! !

!SixxConstants class methodsFor: 'private' stamp: 'mu 6/23/2007 19:06'!
registerToDetectionMaps
	| inst |
	inst := self new.
	self constantsDetectionMap at: inst objectTagName put: self.
	self constantsDetectionMapByRoot at: inst rootTagName put: self! !

!SixxConstants class methodsFor: 'accessing' stamp: 'mu 6/23/2007 19:19'!
rootTagNames
	^self constantsDetectionMapByRoot keys! !

!SixxConstants class methodsFor: 'utility' stamp: 'mu 6/24/2007 18:08'!
setCurrentConstantsBy: sixxElement
	| extrancedName constantClass |
	extrancedName := (SixxXmlUtil nameFrom: sixxElement) asString.

	constantClass := self constantsDetectionMapByRoot at: extrancedName ifAbsent:[
			self constantsDetectionMap at: extrancedName ifAbsent:[]
	].

	"no detected constants"
	constantClass isNil ifTrue: [^nil].

	^self current: constantClass new.

	! !

!SixxConstants class methodsFor: 'utility' stamp: 'mu 3/30/2007 11:39'!
useCompactTags
	"SixxConstants useCompactTags"
	^ self current isMemberOf: SixxCompactConstants! !

!SixxConstants class methodsFor: 'utility' stamp: 'mu 3/30/2007 11:39'!
useCompactTags: aBoolean 
	"SixxConstants useCompactTags: true"
	"SixxConstants useCompactTags: false"
	self
		current: (aBoolean
				ifTrue: [SixxCompactConstants new]
				ifFalse: [self new])! !

!SixxConstants class methodsFor: 'utility' stamp: 'mu 6/6/2007 20:47'!
useReducedTags
	"SixxConstants useReducedTags"
	^ self current isMemberOf: SixxReducedConstants! !

!SixxConstants class methodsFor: 'utility' stamp: 'mu 6/6/2007 20:47'!
useReducedTags: aBoolean 
	"SixxConstants useReducedTags: true"
	"SixxConstants useReducedTags: false"
	self
		current: (aBoolean
				ifTrue: [SixxReducedConstants new]
				ifFalse: [self new])! !

!SixxConstants methodsFor: 'constants-tag name' stamp: 'mu 3/29/2007 22:59'!
envTagName
	^'sixx.env'! !

!SixxConstants methodsFor: 'constants-tag name' stamp: 'mu 3/29/2007 22:53'!
idrefTagName
	^'sixx.idref'! !

!SixxConstants methodsFor: 'constants-tag name' stamp: 'mu 3/29/2007 22:56'!
idTagName
	^'sixx.id'! !

!SixxConstants methodsFor: 'initialize-release' stamp: 'mu 3/31/2007 21:58'!
initialize
	xmlVersion := nil.
	xmlEncoding := nil.
	sixxVersion := nil.
	xmlDeclaration := nil! !

!SixxConstants methodsFor: 'constants-tag name' stamp: 'mu 3/29/2007 22:55'!
nameTagName
	^'sixx.name'! !

!SixxConstants methodsFor: 'constants-tag name' stamp: 'mu 3/29/2007 22:53'!
objectTagName
	^'sixx.object'! !

!SixxConstants methodsFor: 'constants-tag name' stamp: 'mu 3/30/2007 11:21'!
rootTagName
	^'sixx'! !

!SixxConstants methodsFor: 'constants-root' stamp: 'mu 3/30/2007 11:22'!
sixxEndTag
	^SixxXmlUtil contentsWithEndTagNamed: self rootTagName! !

!SixxConstants methodsFor: 'constants-root' stamp: 'mu 3/30/2007 11:29'!
sixxStartTag
	^SixxXmlUtil contentsWithStartTagNamed: self rootTagName do: [:wStr | 
		wStr nextPutAll: self versionTagName;
		 nextPutAll: '="';
		 nextPutAll: self sixxVersion;
		 nextPutAll: '"'.
	] ! !

!SixxConstants methodsFor: 'accessing' stamp: 'kuri-t 5/21/2002 17:59'!
sixxVersion
	sixxVersion isNil ifTrue: [sixxVersion := '1.0'].
	^sixxVersion! !

!SixxConstants methodsFor: 'accessing' stamp: 'mu 3/31/2007 21:57'!
sixxVersion: versionString 
	sixxVersion := versionString! !

!SixxConstants methodsFor: 'constants-tag name' stamp: 'mu 3/29/2007 23:13'!
typeTagName
	^'sixx.type'! !

!SixxConstants methodsFor: 'constants-tag name' stamp: 'mu 3/30/2007 10:47'!
versionTagName
	^'sixx.version'! !

!SixxConstants methodsFor: 'constants-root' stamp: 'mu 3/29/2007 22:39'!
xmlDeclaration
	xmlDeclaration isNil ifTrue: [xmlDeclaration := '<?xml version="', self xmlVersion, '" encoding="', self xmlEncoding, '"?>'].
	^xmlDeclaration
	! !

!SixxConstants methodsFor: 'accessing' stamp: 'kuri-t 5/21/2002 17:58'!
xmlEncoding
	xmlEncoding isNil ifTrue: [xmlEncoding := 'utf-8'].
	^ xmlEncoding! !

!SixxConstants methodsFor: 'accessing' stamp: 'MU 5/23/2002 17:24'!
xmlEncoding: encodingString 
	xmlDeclaration := nil.
	xmlEncoding := encodingString! !

!SixxConstants methodsFor: 'accessing' stamp: 'kuri-t 5/21/2002 17:57'!
xmlVersion
	xmlVersion isNil ifTrue: [xmlVersion := '1.0'].
	^ xmlVersion! !

!SixxConstants methodsFor: 'accessing' stamp: 'MU 5/23/2002 17:24'!
xmlVersion: versionString 
	xmlDeclaration := nil.
	xmlVersion := versionString! !

SixxConstants subclass: #SixxReducedConstants
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxReducedConstants methodsFor: 'constants-tag name' stamp: 'mu 6/6/2007 20:45'!
envTagName
	^'env'! !

!SixxReducedConstants methodsFor: 'constants-tag name' stamp: 'mu 6/6/2007 20:45'!
idrefTagName
	^'idref'! !

!SixxReducedConstants methodsFor: 'constants-tag name' stamp: 'mu 6/6/2007 20:45'!
idTagName
	^'id'! !

!SixxReducedConstants methodsFor: 'constants-tag name' stamp: 'mu 6/6/2007 20:45'!
nameTagName
	^'name'! !

!SixxReducedConstants methodsFor: 'constants-tag name' stamp: 'mu 6/6/2007 20:45'!
objectTagName
	^'object'! !

!SixxReducedConstants methodsFor: 'constants-tag name' stamp: 'mu 6/6/2007 20:46'!
rootTagName
	^'rixx'! !

!SixxReducedConstants methodsFor: 'constants-tag name' stamp: 'mu 6/6/2007 20:45'!
typeTagName
	^'type'! !

!SixxReducedConstants methodsFor: 'constants-tag name' stamp: 'mu 6/6/2007 20:45'!
versionTagName
	^'version'! !

Object subclass: #SixxCustomSerializationExample
	instanceVariableNames: 'varTime varString varNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Examples'!

!SixxCustomSerializationExample class methodsFor: 'sixx-instance creation' stamp: 'mu 3/31/2007 21:52'!
createInstanceOf: aClass withSixxElement: sixxElement
	| stream inst |
	stream := ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement).
	inst := self new.
	inst varTime: (Time readSixxContentStringFrom: (stream upTo: $;) readStream).
	inst varString: (stream upTo: $;).
	inst varNumber: (stream upTo: $;) asNumber.
	^inst! !

!SixxCustomSerializationExample class methodsFor: 'examples' stamp: 'mu 3/31/2007 21:53'!
example1
	"self example1"
	| instA sixx instB |
	instA := self new varTime: Time now; varString: 'Testing'; varNumber: 123.
	sixx := instA sixxString.
	instB := Object readSixxFrom: sixx.
	
	sixx inspect.
	(Array with:instA with: instB) inspect.! !

!SixxCustomSerializationExample methodsFor: 'sixx-printing' stamp: 'mu 3/31/2007 21:51'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self varTime sixxContentString.
	aStream nextPut: $;.
	aStream nextPutAll: self varString.
	aStream nextPut: $;.
	aStream nextPutAll: self varNumber printString.
	aStream nextPut: $;.
	! !

!SixxCustomSerializationExample methodsFor: 'accessing' stamp: 'mu 3/31/2007 21:51'!
varNumber
	"Answer the value of varNumber"

	^ varNumber! !

!SixxCustomSerializationExample methodsFor: 'accessing' stamp: 'mu 3/31/2007 21:51'!
varNumber: anObject
	"Set the value of varNumber"

	varNumber := anObject! !

!SixxCustomSerializationExample methodsFor: 'accessing' stamp: 'mu 3/31/2007 21:51'!
varString
	"Answer the value of varString"

	^ varString! !

!SixxCustomSerializationExample methodsFor: 'accessing' stamp: 'mu 3/31/2007 21:51'!
varString: anObject
	"Set the value of varString"

	varString := anObject! !

!SixxCustomSerializationExample methodsFor: 'accessing' stamp: 'mu 3/31/2007 21:51'!
varTime
	"Answer the value of varTime"

	^ varTime! !

!SixxCustomSerializationExample methodsFor: 'accessing' stamp: 'mu 3/31/2007 21:51'!
varTime: anObject
	"Set the value of varTime"

	varTime := anObject! !

Object subclass: #SixxCustomStoreLoadExample
	instanceVariableNames: 'id cachedData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Examples'!

SixxCustomStoreLoadExample class
	instanceVariableNames: 'instances cachedData'!

!SixxCustomStoreLoadExample commentStamp: '<historical>' prior: 0!
I am an example of SIXX custom serialization.
SIXX normally writes/reads all attribute values (instance variables).
But sometimes this behavior is not appropriate. For example, I would like to omit writing/reading a "cachedData" value, because it is only a cache.

By overriding hook methods below, you can customize what attributes are written or read.

(instance methods)
#sixxIgnorableInstVarNames (for reading/writing)

#sixxContentOn: aStream indent: level context: dictionary (for writing)
#sixxInstVarNamed: instVarName put: aValue (for reading)

(class methods)
#sixxContentOn: aStream indent: level context: dictionary (for writing)
#sixxInstVarNamed: instVarName put: aValue (for reading)

#createInstanceOf: aClass withSixxElement: sixxElement (for writing)
(It is useful for variable objects. See implementors.)

---
MU 6/14/2002 11:12



!

!SixxCustomStoreLoadExample class methodsFor: 'examples' stamp: 'MU 6/14/2002 11:15'!
example1
	"SixxCustomStoreLoadExample example1"
	"Writing custom serialization object"
	| inst xml |
	inst := SixxCustomStoreLoadExample random.
	xml := inst sixxString.
	Transcript cr; show: self name, ' instance sixx is...'; cr; show: xml.
	^xml

! !

!SixxCustomStoreLoadExample class methodsFor: 'examples' stamp: 'MU 6/14/2002 11:15'!
example2
	"SixxCustomStoreLoadExample example2"
	"Reading custom serialization object"
	|  xml inst |
	xml := self example1.
	inst := Object readSixxFrom: xml.
	Transcript cr; show: self name, ' instance is load from XML...'; cr; show: inst.
	^inst

! !

!SixxCustomStoreLoadExample class methodsFor: 'examples' stamp: 'MU 6/14/2002 11:17'!
example3
	"SixxCustomStoreLoadExample example3"
	"Writing custom serialization class object"
	| cls xml |
	cls := SixxCustomStoreLoadExample.
	xml := cls sixxString.
	Transcript cr; show: self name, ' class instance sixx is...'; cr; show: xml.
	^xml

! !

!SixxCustomStoreLoadExample class methodsFor: 'examples' stamp: 'MU 6/14/2002 11:30'!
example4
	"SixxCustomStoreLoadExample example4"
	"Reading custom serialization object"
	| xml cls |
	xml := self example3.
	self instances: nil. "class instances variable is set to nil"
	cls := self readSixxFrom: xml.
	Transcript cr; show: self name, ' cls instance is load from XML...'; cr; show: cls.
	^self instances inspect. "now class instances variable has been set"

! !

!SixxCustomStoreLoadExample class methodsFor: 'instance creation' stamp: 'MU 6/9/2002 19:47'!
id: anInteger
	| inst |
	inst := self new id: anInteger; cachedData: thisContext; yourself.
	self instances add: inst.
	^inst! !

!SixxCustomStoreLoadExample class methodsFor: 'class initialization' stamp: 'MU 6/14/2002 11:25'!
initialize
	"SixxCustomStoreLoadExampleClass initialize"
	instances := OrderedCollection new.
	cachedData := thisContext. "some unstorable cache data"! !

!SixxCustomStoreLoadExample class methodsFor: 'accessing' stamp: 'MU 6/9/2002 19:16'!
instances
	instances isNil ifTrue: [instances := OrderedCollection new].
	^instances! !

!SixxCustomStoreLoadExample class methodsFor: 'accessing' stamp: 'MU 6/9/2002 19:17'!
instances: aValue
	instances := aValue! !

!SixxCustomStoreLoadExample class methodsFor: 'instance creation' stamp: 'MU 6/9/2002 19:50'!
random
	^self id: Random new next! !

!SixxCustomStoreLoadExample class methodsFor: 'sixx writing/reading' stamp: 'mu 8/2/2006 20:52'!
sixxContentOn: aStream indent: level context: dictionary 
	"override if you like"
	aStream cr.
	self instances
		sixxOn: aStream
		name: 'instances'
		indent: level + 1
		context: dictionary.
	aStream tab: level! !

!SixxCustomStoreLoadExample class methodsFor: 'sixx writing/reading' stamp: 'mu 12/25/2006 16:38'!
sixxInstVarNamed: instVarName put: aValue 
	"override if you like"
	instVarName == #instances ifTrue: [self instances: aValue]! !

!SixxCustomStoreLoadExample methodsFor: 'accessing' stamp: 'MU 6/9/2002 19:41'!
cachedData
	^cachedData! !

!SixxCustomStoreLoadExample methodsFor: 'accessing' stamp: 'MU 6/9/2002 19:42'!
cachedData: aValue
	cachedData := aValue! !

!SixxCustomStoreLoadExample methodsFor: 'accessing' stamp: 'MU 6/9/2002 18:33'!
id
	^id! !

!SixxCustomStoreLoadExample methodsFor: 'accessing' stamp: 'MU 6/9/2002 18:33'!
id: anInteger
	id := anInteger! !

!SixxCustomStoreLoadExample methodsFor: 'sixx writing/reading' stamp: 'mu 1/15/2007 18:05'!
sixxIgnorableInstVarNames
	^#(#cachedData)! !

Object subclass: #SixxExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Examples'!

!SixxExamples commentStamp: '<historical>' prior: 0!
SIXX basic examples: see class side.
---
MU 6/14/2002 11:12!

!SixxExamples class methodsFor: 'examples' stamp: 'MU 6/9/2002 02:10'!
example1
	"SixxExamples example1"
	"Create a SIXX string from an object (like #storeString)"
	
	| dict array xmlString |
	dict := Dictionary new.
	dict at: #Smalltalk put: 'Best'.
	dict at: #Ruby put: 'Cool'.
	dict at: #Java put: 'Forget it'.
	array := Array new:3.
	array at: 1 put: 'Language Impressions'.
	array at: 2 put: dict.
	array at: 3 put: Date today.
	xmlString := array sixxString.
	Transcript cr; show: '##This is sixx xml instance##'. 
	Transcript cr; show: xmlString.
	
	^xmlString ! !

!SixxExamples class methodsFor: 'examples' stamp: 'MU 6/9/2002 02:53'!
example2
	"SixxExamples example2"
	"Read a SIXX string and restore an instance (like #readFrom:)"
	
	| xmlString obj |
	xmlString := SixxExamples example1.
	obj := Object readSixxFrom: xmlString.
	obj inspect. ! !

!SixxExamples class methodsFor: 'examples' stamp: 'MU 6/9/2002 02:35'!
example3
	"SixxExamples example3"
	"Resolve circular and shared objects"
	
	| rootOrdered sharedDict subOrdered subArray xmlString obj |
	rootOrdered := OrderedCollection new.
	sharedDict := Dictionary new.
	sharedDict at: #hello put: 'Hello'.
	sharedDict at: #recurHello put: sharedDict.
	subOrdered := OrderedCollection new.
	subOrdered add: sharedDict.
	subOrdered add: Time now.
	subArray := Array new: 2.
	subArray at: 1 put: sharedDict.
	subArray at: 2 put: Date today.
	rootOrdered add: subOrdered; add: subArray.
	
	xmlString := rootOrdered sixxString.
	Transcript cr; show: '##This is sixx xml instance##'. 
	Transcript cr; show: xmlString.
	
	obj := Object readSixxFrom: xmlString.
	Transcript cr; show: '##Shared object comparison##'. 
	Transcript cr; show: obj first first = obj last first.
	obj inspect. 
	
	
	

! !

!SixxExamples class methodsFor: 'examples' stamp: 'MU 6/9/2002 02:36'!
example4
	"SixxExamples example4"
	"Save and load Preferences data"
	
	| preferences |
	preferences := Preferences allPreferenceObjects sixxString.
	preferences := Object readSixxFrom: preferences.
	^preferences inspect.

	

! !

!SixxExamples class methodsFor: 'examples' stamp: 'MU 6/14/2002 11:56'!
example5
	"SixxExamples example5"
	"Write object data to an external file"
	
	| sws |
	sws := SixxWriteStream newFileNamed: ('obj.sixx').
	sws nextPut: Color random.
	sws nextPut: Rectangle fromUser.
	sws nextPut: View subclasses.
	sws nextPutAll: View subclasses. "note the differences"
	sws close.
! !

!SixxExamples class methodsFor: 'examples' stamp: 'MU 6/9/2002 02:45'!
example6
	"SixxExamples example6"
	"Read object data from an external file"
	
	| srs objects |
	srs := SixxReadStream readOnlyFileNamed: ('obj.sixx').
	objects := OrderedCollection new.
	[srs atEnd] whileFalse: [objects add: srs next].
	srs close.
	objects inspect.
! !

!SixxExamples class methodsFor: 'examples' stamp: 'MU 9/19/2002 00:45'!
example7
	"SixxExamples example7"

	"Write object data to an external file"

	| sws dic |
	sws := SixxWriteStream newFileNamed: 'obj2.sixx'.
	sws nextPut: Color red.
	sws nextPut: Rectangle fromUser.
	sws nextPut: true.
	sws nextPut: false.
	sws nextPut: $a.
	sws nextPut: $(.
	sws nextPut: (OrderedCollection with: 1 with: Date today).
	sws nextPut: Time now.
	sws nextPut: nil.
	sws nextPut: (ByteArray 
				with: 10
				with: 20
				with: 30).
	dic := Dictionary new.
	dic at: 'first' put: '111'.
	dic at: 'second' put: '222'.
	sws nextPut: dic.
	sws close! !

Object variableSubclass: #SixxMockBinaryData
	instanceVariableNames: 'author version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockBinaryData class methodsFor: 'instance creation' stamp: 'MU 10/21/2002 01:03'!
author: author version: version data: binaryData
	"SixxMockBinaryData author: 'MU' version: '0.1' data: #(1 2 3)"
	| inst idx |
	inst := self new: binaryData size.
	idx := 0.
	binaryData do: [:each | inst at: (idx := idx + 1) put: each].
	inst author: author.
	inst version: version.
	^inst

! !

!SixxMockBinaryData methodsFor: 'accessing' stamp: 'MU 10/20/2002 22:58'!
author
	^author! !

!SixxMockBinaryData methodsFor: 'accessing' stamp: 'MU 10/20/2002 22:59'!
author: aString
	author :=  aString
! !

!SixxMockBinaryData methodsFor: 'accessing' stamp: 'MU 10/20/2002 22:59'!
version
	^version! !

!SixxMockBinaryData methodsFor: 'accessing' stamp: 'MU 10/20/2002 23:00'!
version: aString
	version :=  aString
! !

Object subclass: #SixxMockCustomWriteObject
	instanceVariableNames: 'name time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockCustomWriteObject methodsFor: 'initialize-release' stamp: 'mu 12/13/2006 23:07'!
initialize
	name := 'TestName'.
	time := Time now printString! !

!SixxMockCustomWriteObject methodsFor: 'accessing' stamp: 'mu 12/13/2006 23:08'!
name
	^name! !

!SixxMockCustomWriteObject methodsFor: 'accessing' stamp: 'mu 12/13/2006 23:07'!
name: anObject
	"Set the value of name"

	name := anObject! !

!SixxMockCustomWriteObject methodsFor: 'sixx-writing' stamp: 'mu 12/13/2006 23:09'!
sixxWriteValue
	"Write myself as an array"
	^SixxMockMementoArray with: self name with: self time! !

!SixxMockCustomWriteObject methodsFor: 'accessing' stamp: 'mu 12/13/2006 23:07'!
time
	"Answer the value of time"

	^ time! !

!SixxMockCustomWriteObject methodsFor: 'accessing' stamp: 'mu 12/13/2006 23:07'!
time: anObject
	"Set the value of time"

	time := anObject! !

Object subclass: #SixxMockEnvelope
	instanceVariableNames: 'header'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockEnvelope class methodsFor: 'instance creation' stamp: 'mu 5/10/2002 17:48'!
header: aHeader
	super initialize.
	^ self new header: aHeader! !

!SixxMockEnvelope methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:48'!
header
	^ header! !

!SixxMockEnvelope methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:48'!
header: aHeader
	header := aHeader! !

Object subclass: #SixxMockFixedNewFailedClass
	instanceVariableNames: 'att1 att2 att3Block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

SixxMockFixedNewFailedClass subclass: #SixxMockFixedAlternativeClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockFixedAlternativeClass class methodsFor: 'instance creation' stamp: 'mu 6/24/2004 23:02'!
new
	"new is OK for me"
	^self basicNew! !

!SixxMockFixedNewFailedClass class methodsFor: 'instance creation' stamp: 'mu 6/24/2004 22:32'!
new
	^Error new signal: '#new should not be used!!'! !

!SixxMockFixedNewFailedClass class methodsFor: 'for tests' stamp: 'mu 6/24/2004 22:37'!
prototype1
	"self prototype1"
	| inst |
	inst := self basicNew.
	inst att1: 1.
	inst att2: 'TWO'.
	inst att3Block: [:this | 'is block'].
	^inst! !

!SixxMockFixedNewFailedClass class methodsFor: 'for tests' stamp: 'mu 6/24/2004 22:45'!
prototype2
	"self prototype2"
	| inst |
	inst := self basicNew.
	inst att1: 3.
	inst att2: 'Four'.
	inst att3Block: [:this :is | 'block2'].
	^inst! !

!SixxMockFixedNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/24/2004 22:33'!
att1
	^att1! !

!SixxMockFixedNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/24/2004 22:33'!
att1: aValue
	att1 := aValue! !

!SixxMockFixedNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/24/2004 22:33'!
att2
	^att2! !

!SixxMockFixedNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/24/2004 22:33'!
att2: aValue
	att2 := aValue! !

!SixxMockFixedNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/24/2004 22:36'!
att3Block
	^att3Block! !

!SixxMockFixedNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/24/2004 22:36'!
att3Block: aValue
	att3Block := aValue! !

!SixxMockFixedNewFailedClass methodsFor: 'initializing-sixx' stamp: 'mu 6/24/2004 22:34'!
sixxInitialize
	att3Block := [:a :b | a < b].! !

Object subclass: #SixxMockHeader
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockHeader class methodsFor: 'instance creation' stamp: 'mu 5/10/2002 17:48'!
id: aString
	^ self new id: aString! !

!SixxMockHeader methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:48'!
id
	^ id! !

!SixxMockHeader methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:48'!
id: aString
	id := aString! !

Object subclass: #SixxMockObjectWithCache
	instanceVariableNames: 'name att1 att2 cache1 cache2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

SixxMockObjectWithCache subclass: #SixxMockObjectInitializingOnRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockObjectInitializingOnRead methodsFor: '*sixx-initializing' stamp: 'mu 12/17/2006 22:37'!
sixxInitialize
	cache1 := 1234567.
	cache2 := 'this is cache2'! !

SixxMockObjectWithCache subclass: #SixxMockObjectPreparingOnWrite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockObjectPreparingOnWrite methodsFor: 'sixx-writing' stamp: 'mu 1/15/2007 18:34'!
sixxPrepareWrite
	self att1: self att1 printString.
	self att2: self att2 * 2.! !

!SixxMockObjectWithCache methodsFor: 'accessing' stamp: 'mu 12/17/2006 21:56'!
att1
	"Answer the value of att1"

	^ att1! !

!SixxMockObjectWithCache methodsFor: 'accessing' stamp: 'mu 12/17/2006 21:56'!
att1: anObject
	"Set the value of att1"

	att1 := anObject! !

!SixxMockObjectWithCache methodsFor: 'accessing' stamp: 'mu 12/17/2006 21:56'!
att2
	"Answer the value of att2"

	^ att2! !

!SixxMockObjectWithCache methodsFor: 'accessing' stamp: 'mu 12/17/2006 21:56'!
att2: anObject
	"Set the value of att2"

	att2 := anObject! !

!SixxMockObjectWithCache methodsFor: 'accessing' stamp: 'mu 12/17/2006 21:56'!
cache1
	"Answer the value of cache1"

	^ cache1! !

!SixxMockObjectWithCache methodsFor: 'accessing' stamp: 'mu 12/17/2006 21:56'!
cache1: anObject
	"Set the value of cache1"

	cache1 := anObject! !

!SixxMockObjectWithCache methodsFor: 'accessing' stamp: 'mu 12/17/2006 21:57'!
cache2
	"Answer the value of cache2"

	^ cache2! !

!SixxMockObjectWithCache methodsFor: 'accessing' stamp: 'mu 12/17/2006 21:57'!
cache2: anObject
	"Set the value of cache2"

	cache2 := anObject! !

!SixxMockObjectWithCache methodsFor: 'accessing' stamp: 'mu 12/17/2006 21:57'!
name
	^name! !

!SixxMockObjectWithCache methodsFor: 'accessing' stamp: 'mu 12/17/2006 21:56'!
name: anObject
	"Set the value of name"

	name := anObject! !

!SixxMockObjectWithCache methodsFor: 'sixx-writing' stamp: 'mu 1/15/2007 18:05'!
sixxIgnorableInstVarNames
	^#(#cache1 #cache2)! !

Object subclass: #SixxMockObjectWithId
	instanceVariableNames: 'id data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockObjectWithId class methodsFor: 'instance creation' stamp: 'mu 6/24/2007 16:10'!
id: anId
	^self new id: anId; yourself! !

!SixxMockObjectWithId methodsFor: 'accessing' stamp: 'mu 6/24/2007 16:55'!
data
	"Answer the value of data"

	^ data! !

!SixxMockObjectWithId methodsFor: 'accessing' stamp: 'mu 6/24/2007 16:56'!
data: anObject
	"Set the value of data"

	data := anObject! !

!SixxMockObjectWithId methodsFor: 'accessing' stamp: 'mu 6/24/2007 16:03'!
id
	"Answer the value of id"

	^ id! !

!SixxMockObjectWithId methodsFor: 'accessing' stamp: 'mu 6/24/2007 16:03'!
id: anObject
	"Set the value of id"

	id := anObject! !

!SixxMockObjectWithId methodsFor: 'sixx' stamp: 'mu 6/24/2007 16:05'!
sixxReferenceIdInContext: dictionary
	"override if you would like to generate id by yourself"
	^self id! !

Object subclass: #SixxMockOldShapeObject
	instanceVariableNames: 'oldNamedVar1 originalAtt1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockOldShapeObject methodsFor: 'accessing' stamp: 'mu 12/22/2006 15:34'!
oldNamedVar1
	"Answer the value of oldNamedVar1"

	^ oldNamedVar1! !

!SixxMockOldShapeObject methodsFor: 'accessing' stamp: 'mu 12/22/2006 15:34'!
oldNamedVar1: anObject
	"Set the value of oldNamedVar1"

	oldNamedVar1 := anObject! !

!SixxMockOldShapeObject methodsFor: 'accessing' stamp: 'mu 12/22/2006 15:34'!
originalAtt1
	"Answer the value of originalAtt1"

	^ originalAtt1! !

!SixxMockOldShapeObject methodsFor: 'accessing' stamp: 'mu 12/22/2006 15:34'!
originalAtt1: anObject
	"Set the value of originalAtt1"

	originalAtt1 := anObject! !

Object subclass: #SixxMockShapeChangedObject
	instanceVariableNames: 'renamedAtt1 addedAtt1 originalAtt1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockShapeChangedObject methodsFor: 'accessing' stamp: 'mu 12/22/2006 14:59'!
addedAtt1
	"Answer the value of addedAtt1"

	^ addedAtt1! !

!SixxMockShapeChangedObject methodsFor: 'accessing' stamp: 'mu 12/22/2006 14:59'!
addedAtt1: anObject
	"Set the value of addedAtt1"

	addedAtt1 := anObject! !

!SixxMockShapeChangedObject methodsFor: 'accessing' stamp: 'mu 12/22/2006 14:59'!
originalAtt1
	"Answer the value of originalAtt1"

	^ originalAtt1! !

!SixxMockShapeChangedObject methodsFor: 'accessing' stamp: 'mu 12/22/2006 14:59'!
originalAtt1: anObject
	"Set the value of originalAtt1"

	originalAtt1 := anObject! !

!SixxMockShapeChangedObject methodsFor: 'accessing' stamp: 'mu 12/22/2006 14:59'!
renamedAtt1
	"Answer the value of renamedAtt1"

	^ renamedAtt1! !

!SixxMockShapeChangedObject methodsFor: 'accessing' stamp: 'mu 12/22/2006 14:59'!
renamedAtt1: anObject
	"Set the value of renamedAtt1"

	renamedAtt1 := anObject! !

!SixxMockShapeChangedObject methodsFor: 'sixx-shapeChange' stamp: 'mu 12/22/2006 15:06'!
sixxInitialize
	addedAtt1 := 2! !

!SixxMockShapeChangedObject methodsFor: 'sixx-shapeChange' stamp: 'mu 12/25/2006 16:38'!
sixxInstVarNamed: varName put: value
	varName == #oldNamedVar1 ifTrue: [^self renamedAtt1: value].

	super sixxInstVarNamed: varName put: value! !

Object subclass: #SixxMockShapeChangedObjectWithoutShapeChangeMethods
	instanceVariableNames: 'renamedAtt1 addedAtt1 originalAtt1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockShapeChangedObjectWithoutShapeChangeMethods methodsFor: 'accessing' stamp: 'mu 12/22/2006 16:19'!
addedAtt1
	"Answer the value of addedAtt1"

	^ addedAtt1! !

!SixxMockShapeChangedObjectWithoutShapeChangeMethods methodsFor: 'accessing' stamp: 'mu 12/22/2006 16:19'!
addedAtt1: anObject
	"Set the value of addedAtt1"

	addedAtt1 := anObject! !

!SixxMockShapeChangedObjectWithoutShapeChangeMethods methodsFor: 'accessing' stamp: 'mu 12/22/2006 16:19'!
originalAtt1
	"Answer the value of originalAtt1"

	^ originalAtt1! !

!SixxMockShapeChangedObjectWithoutShapeChangeMethods methodsFor: 'accessing' stamp: 'mu 12/22/2006 16:19'!
originalAtt1: anObject
	"Set the value of originalAtt1"

	originalAtt1 := anObject! !

!SixxMockShapeChangedObjectWithoutShapeChangeMethods methodsFor: 'accessing' stamp: 'mu 12/22/2006 16:19'!
renamedAtt1
	"Answer the value of renamedAtt1"

	^ renamedAtt1! !

!SixxMockShapeChangedObjectWithoutShapeChangeMethods methodsFor: 'accessing' stamp: 'mu 12/22/2006 16:19'!
renamedAtt1: anObject
	"Set the value of renamedAtt1"

	renamedAtt1 := anObject! !

Object subclass: #SixxMockSuperClassForUnitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

SixxMockSuperClassForUnitTest class
	instanceVariableNames: 'instVar1 instVar2'!

SixxMockSuperClassForUnitTest subclass: #SixxMockClassForUnitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

SixxMockClassForUnitTest class
	instanceVariableNames: 'instVar3'!

!SixxMockClassForUnitTest class methodsFor: 'class initialization' stamp: 'mu 5/10/2002 17:48'!
initialize
	"MockClassForUnitTest initialize"
	super initialize.
	instVar3 := nil.! !

!SixxMockClassForUnitTest class methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:48'!
instVar3
	instVar3 isNil ifTrue: [instVar3 := ''].
	^instVar3! !

!SixxMockClassForUnitTest class methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:48'!
instVar3: aString
	instVar3 := aString! !

!SixxMockSuperClassForUnitTest class methodsFor: 'class initialization' stamp: 'mu 5/10/2002 17:47'!
initialize
	"MockSuperClassForUnitTest initialize"
	super initialize.
	instVar1 := nil.
	instVar2 := nil.! !

!SixxMockSuperClassForUnitTest class methodsFor: 'accessing' stamp: 'kuri-t 6/10/2002 14:44'!
instVar1
	instVar1 isNil
		ifTrue: [instVar1 := ''].
	^ instVar1! !

!SixxMockSuperClassForUnitTest class methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:47'!
instVar1: aString
	instVar1 := aString! !

!SixxMockSuperClassForUnitTest class methodsFor: 'accessing' stamp: 'kuri-t 6/10/2002 14:44'!
instVar2
	instVar2 isNil
		ifTrue: [instVar2 := ''].
	^ instVar2! !

!SixxMockSuperClassForUnitTest class methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:47'!
instVar2: aString
	instVar2 := aString! !

Object subclass: #SixxMorphMemento
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Examples'!

!SixxMorphMemento commentStamp: '<historical>' prior: 0!
I am an example of SIXX custom serialization.
I am useful only in Squeak environment, because I write/read a morph in SIXX.

---
MU 6/14/2002 11:12!

SixxMorphMemento subclass: #SixxAutoMorphMemento
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Examples'!

SixxAutoMorphMemento class
	instanceVariableNames: 'instDict'!

!SixxAutoMorphMemento commentStamp: 'mu 12/22/2006 15:19' prior: 0!
I am an example of SIXX custom serialization.
I show the #sixxReadValue hook usage pattern.

1. Implement #sixxWriteValue your morph to return me. 

sixxWriteValue
 ^SixxAutoMorphMemento on: self 

2. just use #sixxString and #readSixxFrom: as usual. The stored object will be a memento, and it will be automatically restored as a real object (morph) in loading.

---
MU 11/10/2006 14:35!

!SixxAutoMorphMemento class methodsFor: 'class initialization' stamp: 'mu 11/10/2006 17:28'!
initialize
	"SixxAutoMorphMemento initialize"
	self release.
	Smalltalk addToStartUpList: self! !

!SixxAutoMorphMemento class methodsFor: 'accessing' stamp: 'mu 11/10/2006 14:35'!
instDict
	^instDict ifNil: [instDict _ IdentityDictionary new].! !

!SixxAutoMorphMemento class methodsFor: 'accessing' stamp: 'mu 11/10/2006 14:35'!
instDict: aDictionary
	instDict _ aDictionary! !

!SixxAutoMorphMemento class methodsFor: 'class initialization' stamp: 'mu 11/10/2006 17:28'!
obsolete
	
	Smalltalk removeFromStartUpList: self! !

!SixxAutoMorphMemento class methodsFor: 'instance creation' stamp: 'mu 12/22/2006 15:23'!
on: aMorph
	"You have to return the same memento instance on a Morph"
	^self instDict at: aMorph ifAbsentPut: [super on: aMorph]
	! !

!SixxAutoMorphMemento class methodsFor: 'class initialization' stamp: 'mu 11/10/2006 17:28'!
release
	instDict _ nil.

	! !

!SixxAutoMorphMemento class methodsFor: 'starting' stamp: 'mu 11/10/2006 17:28'!
startUp
	self release! !

!SixxAutoMorphMemento methodsFor: 'converting' stamp: 'mu 11/10/2006 17:21'!
sixxReadValue
	"return morph when loaded"
	^self morph! !

!SixxMorphMemento class methodsFor: 'examples' stamp: 'MU 6/14/2002 12:34'!
example1
	"SixxMorphMemento example1"
	"Create a SIXX string from an StarMorph"

	| morph memento |
	morph := StarMorph new openInWorld.
	memento := SixxMorphMemento on: morph.
	^memento sixxString! !

!SixxMorphMemento class methodsFor: 'examples' stamp: 'MU 6/14/2002 12:34'!
example2
	"SixxMorphMemento example2"
	"Read a SIXX string and restore a StarMorph. Original StarMorph is still there"

	| xmlMorphString memento morph |
	xmlMorphString := self example1.
	memento := Object readSixxFrom: xmlMorphString.
	morph := memento morph.
	morph openInWorld.
	morph color: Color random.
	morph position: (morph position + (20@20)).
	^morph! !

!SixxMorphMemento class methodsFor: 'examples' stamp: 'MU 6/14/2002 13:30'!
example3
	"SixxMorphMemento example3"
	"Write object data to an external file"

	| sws  |
	sws := SixxWriteStream newFileNamed: ('morph.sixx').
	sws nextPut: (SixxMorphMemento on: (BouncingAtomsMorph new position: 200@200)).
	sws close.! !

!SixxMorphMemento class methodsFor: 'examples' stamp: 'MU 6/14/2002 12:37'!
example4
	"SixxMorphMemento example4"
	"Read a Mprph from an external file"

	| srs memento morph |
	srs := SixxReadStream readOnlyFileNamed: ('morph.sixx').
	memento := srs next.
	srs close.
	morph := memento morph.
	morph openInWorld.
	morph inspect.! !

!SixxMorphMemento class methodsFor: 'instance creation' stamp: 'MU 6/14/2002 11:52'!
on: aMorph
	^self new morph: aMorph; yourself! !

!SixxMorphMemento methodsFor: 'accessing' stamp: 'MU 6/14/2002 11:33'!
morph
	^morph! !

!SixxMorphMemento methodsFor: 'private' stamp: 'MU 6/14/2002 12:28'!
morphForStore
	| file con |
	self morph allMorphsDo: [:m | m prepareToBeSaved].
	file := RWBinaryOrTextStream on: (ByteArray new: 5000).
	file binary.
	(self streamClass on: file)	nextPut: self morph.
	con := Base64MimeConverter mimeEncode: file reset.
	file close.
	^con contents
! !

!SixxMorphMemento methodsFor: 'private' stamp: 'MU 6/14/2002 12:27'!
morphFrom: aString
	| byteStr oStr |
	byteStr := (Base64MimeConverter mimeDecodeToBytes: (ReadStream on: aString)).
	oStr := self streamClass on: byteStr.
	^oStr next
! !

!SixxMorphMemento methodsFor: 'accessing' stamp: 'MU 6/14/2002 11:33'!
morph: aMorph
	morph := aMorph! !

!SixxMorphMemento methodsFor: 'writing/reading sixx' stamp: 'MU 6/14/2002 11:54'!
sixxContentOn: aStream indent: level context: dictionary 
	"override if you like"
	aStream cr.
	self morphForStore
		sixxOn: aStream
		name: 'morph'
		indent: level + 1
		context: dictionary.
	aStream tab: level! !

!SixxMorphMemento methodsFor: 'writing/reading sixx' stamp: 'mu 12/25/2006 16:39'!
sixxInstVarNamed: instVarName put: aValue 
	"override if you like"
	instVarName == #morph ifTrue: [self morph: (self morphFrom: aValue)]! !

!SixxMorphMemento methodsFor: 'factory' stamp: 'MU 6/14/2002 12:27'!
streamClass
	^ReferenceStream! !

Object subclass: #SixxPortableUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Squeak'!

SixxPortableUtil class
	instanceVariableNames: 'settings'!

!SixxPortableUtil class methodsFor: 'actions' stamp: 'mu 9/13/2006 13:02'!
charCodeOf: aCharacter
	^aCharacter asUnicode! !

!SixxPortableUtil class methodsFor: 'actions' stamp: 'mu 1/16/2007 11:58'!
classAt: localClassName in: environmentQualifier 
	"#Squeak Specific#"
	| foundClass classNameSymbol |
	foundClass := nil.
	classNameSymbol := self mappedClassNameFor: localClassName asSymbol.
	
	foundClass := self settings useEnvironment
				ifTrue: [| env | 
					env := environmentQualifier isNil
								ifTrue: [Smalltalk]
								ifFalse: ["Currently Squeak does not support  
									namespace, so just ignore"
									Smalltalk].
					env
						at: classNameSymbol
						ifAbsent: []]
				ifFalse: [Smalltalk
						at: classNameSymbol
						ifAbsent: []].
	^ foundClass! !

!SixxPortableUtil class methodsFor: 'actions' stamp: 'MU 3/6/2003 15:55'!
environmentQualifierOf: aClass
	"#Squeak Specific#"
	"Currently Squeak does not support namespace, so just ignore"
	^'Smalltalk'! !

!SixxPortableUtil class methodsFor: 'class initialization' stamp: 'mu 12/25/2006 10:28'!
initialize
	settings := nil! !

!SixxPortableUtil class methodsFor: 'actions' stamp: 'mu 1/16/2007 11:57'!
mappedClassNameFor: classNameSymbol
	
	^classNameSymbol! !

!SixxPortableUtil class methodsFor: 'class initialization' stamp: 'MU 3/18/2003 18:32'!
obsolete
	self initialize! !

!SixxPortableUtil class methodsFor: 'actions' stamp: 'MU 6/11/2002 12:29'!
readFileStreamNamed: aFilename
	"#Squeak Specific#"
	^CrLfFileStream readOnlyFileNamed: aFilename.! !

!SixxPortableUtil class methodsFor: 'accessing' stamp: 'mu 12/25/2006 10:30'!
settings
	settings isNil
		ifTrue: [settings := Smalltalk
						at: #SixxSettings
						ifAbsent: [self error: 'SixxSettings is needed to run SIXX']].
	^ settings! !

!SixxPortableUtil class methodsFor: 'actions' stamp: 'MU 6/11/2003 17:26'!
signalException: anException
	"#Squeak Specific#"

	^anException signal! !

!SixxPortableUtil class methodsFor: 'actions' stamp: 'MU 6/11/2002 12:35'!
writeFileStreamNamed: aFilename
	"#Squeak Specific#"
	^CrLfFileStream newFileNamed: aFilename.! !

Object subclass: #SixxReadStream
	instanceVariableNames: 'stream sixxElements contextDictionary position limit cachedObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxReadStream commentStamp: '<historical>' prior: 0!
I represent a ReadStream for SIXX format.

I can be used as follows:

srs := SixxReadStream readOnlyFileNamed: ('obj.sixx').
obj := srs next.
srs close.
obj inspect.

srs := SixxReadStream readOnlyFileNamed: ('objs.sixx').
objs := srs contents.
srs close.
objs inspect.

---
[:masashi | ^umezawa]!

!SixxReadStream class methodsFor: 'instance creation' stamp: 'mu 6/23/2007 18:02'!
new
	SixxError signal: 'Streams are created with on:'! !

!SixxReadStream class methodsFor: 'instance creation' stamp: 'kuri-t 5/31/2002 16:42'!
on: readStream 
	^ self basicNew on: readStream! !

!SixxReadStream class methodsFor: 'instance creation' stamp: 'kuri-t 5/21/2002 15:22'!
readOnlyFileNamed: fileName 
	^ self basicNew readOnlyFileNamed: fileName! !

!SixxReadStream methodsFor: 'testing' stamp: 'kuri-t 5/20/2002 18:54'!
atEnd
	^ self position >= self limit! !

!SixxReadStream methodsFor: 'accessing' stamp: 'kuri-t 5/31/2002 16:51'!
cachedObjects
	^ cachedObjects! !

!SixxReadStream methodsFor: 'private' stamp: 'mu 6/24/2007 17:24'!
checkSixxElement: sixxElement 
	| detected |
	detected := SixxConstants setCurrentConstantsBy: sixxElement.
	detected isNil
		ifTrue: [SixxInvalidFormat signal: 'unexpected element: ' , (SixxXmlUtil nameFrom: sixxElement) printString]! !

!SixxReadStream methodsFor: 'file open/close' stamp: 'MU 5/31/2002 12:09'!
close
	self stream close! !

!SixxReadStream methodsFor: 'reading' stamp: 'MU 6/7/2002 18:08'!
contents
	^(self next: self size) asArray! !

!SixxReadStream methodsFor: 'accessing' stamp: 'kuri-t 5/21/2002 15:14'!
contextDictionary
	^ contextDictionary! !

!SixxReadStream methodsFor: 'private-recovery' stamp: 'MU 5/24/2003 18:39'!
findStringIndexes: subString from: sourceString 
	| foundIndexes index |
	foundIndexes := OrderedCollection new.
	index := 1.
	[index = 0]
		whileFalse: [index := sourceString findString: subString startingAt: index.
			index = 0
				ifFalse: [foundIndexes add: index.
					index := index + 1]].
	^ foundIndexes! !

!SixxReadStream methodsFor: 'private' stamp: 'mu 6/24/2007 18:09'!
initialElementsFrom: rootOrElements 
	| extractedName |
	extractedName := SixxXmlUtil nameFrom: rootOrElements.
	^ (SixxConstants rootTagNames includes: extractedName asString)
		ifTrue: [SixxXmlUtil elementsFrom: rootOrElements]
		ifFalse: [OrderedCollection with: rootOrElements] "we allow no root tag"! !

!SixxReadStream methodsFor: 'initializing' stamp: 'kuri-t 5/31/2002 17:16'!
initialize
	contextDictionary := IdentityDictionary new.
	position := 0.
	sixxElements := self parseStream: stream.
	limit := sixxElements isNil
				ifTrue: [0]
				ifFalse: [sixxElements size].
	cachedObjects := Dictionary new! !

!SixxReadStream methodsFor: 'accessing' stamp: 'kuri-t 5/21/2002 15:16'!
limit
	^ limit! !

!SixxReadStream methodsFor: 'reading' stamp: 'mu 12/19/2006 18:44'!
next
	^ self atEnd
		ifFalse: [position := position + 1. 
				self cachedObjects
						at: position
						ifAbsentPut: [self
								readSixxFromSixxElement: (sixxElements at: position)]]! !

!SixxReadStream methodsFor: 'reading' stamp: 'MU 5/31/2002 12:29'!
next: anInteger 
	| ord |
	anInteger < 0 ifTrue: [^nil].
	ord := OrderedCollection new: anInteger.
	anInteger
		timesRepeat: [self atEnd
				ifFalse: [ord add: self next]].
	^ ord! !

!SixxReadStream methodsFor: 'initializing' stamp: 'MU 5/31/2002 12:03'!
on: aStream 
	stream := aStream.
	self initialize! !

!SixxReadStream methodsFor: 'private' stamp: 'mu 6/23/2007 19:17'!
parseStream: aStream 
	| root str recoverTried |
	(aStream isNil or: [aStream size = 0])	ifTrue: [^nil].
	str := aStream.
	recoverTried := false.
	[root := SixxXmlUtil parseXml: str]
		on: SixxXmlParseError do: [:ex | (SixxSettings useRecoveryRead and: [recoverTried not])
			ifTrue: 
				[str := self recoveredStreamFrom: str.
				recoverTried := true.
				ex retry]
			ifFalse: [ex pass]].
	self checkSixxElement: root.
	^self initialElementsFrom: root! !

!SixxReadStream methodsFor: 'reading' stamp: 'MU 5/31/2002 12:36'!
peek
	| nextObj |
	nextObj := self next.
	self privatePosition: self position - 1.
	^ nextObj! !

!SixxReadStream methodsFor: 'reading' stamp: 'kuri-t 5/21/2002 15:14'!
position
	^ position! !

!SixxReadStream methodsFor: 'reading' stamp: 'kuri-t 5/31/2002 16:32'!
position: anInteger 
	(anInteger < 0
			and: [anInteger > limit])
		ifTrue: [self error: 'out of bounds'].
	self reset.
	self next: anInteger! !

!SixxReadStream methodsFor: 'private-accessing' stamp: 'MU 5/31/2002 14:45'!
privatePosition: anInteger 
	
	position := anInteger! !

!SixxReadStream methodsFor: 'initializing' stamp: 'MU 6/11/2002 12:29'!
readOnlyFileNamed: fileName 
	stream := SixxPortableUtil readFileStreamNamed: fileName.
	self initialize! !

!SixxReadStream methodsFor: 'private' stamp: 'kuri-t 5/20/2002 16:51'!
readSixxFromSixxElement: sixxElement 
	^ Object readSixxFromSixxElement: sixxElement context: self contextDictionary! !

!SixxReadStream methodsFor: 'private-recovery' stamp: 'mu 3/30/2007 12:28'!
recoveredStreamFrom: aStream 
	| contents objectTagName objectTagStart objectTagEnd startIndexes endIndexes recoverStream  |
	contents := aStream contents.
	objectTagName := SixxConstants current objectTagName.
	objectTagStart := '<', objectTagName.
	objectTagEnd := SixxXmlUtil contentsWithEndTagNamed: objectTagName.

	startIndexes := self findStringIndexes: objectTagStart from: contents.
	endIndexes := self findStringIndexes: objectTagEnd from: contents.

	recoverStream := ReadWriteStream with: (contents copyFrom: 1 to: (startIndexes last -1)).
	(startIndexes size - endIndexes size -1) timesRepeat: [recoverStream nextPutAll: objectTagEnd].
	recoverStream nextPutAll: (SixxConstants current sixxEndTag).

	^ recoverStream reset! !

!SixxReadStream methodsFor: 'reading' stamp: 'MU 5/31/2002 12:36'!
reset
	self privatePosition: 0! !

!SixxReadStream methodsFor: 'accessing' stamp: 'kuri-t 5/21/2002 15:15'!
sixxElements
	^ sixxElements! !

!SixxReadStream methodsFor: 'reading' stamp: 'kuri-t 5/21/2002 11:54'!
size
	^ self limit! !

!SixxReadStream methodsFor: 'reading' stamp: 'kuri-t 5/31/2002 16:06'!
skip: anInteger
	self position: self position + anInteger.! !

!SixxReadStream methodsFor: 'accessing' stamp: 'kuri-t 5/17/2002 15:25'!
stream
	^ stream! !

SixxReadStream subclass: #SixxShapeChangeReadStream
	instanceVariableNames: 'shapeChangeClassResolver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxShapeChangeReadStream commentStamp: 'mu 1/15/2007 17:04' prior: 0!
I can read class shape changed instances. I support renamed, removed and newly added instance variables.

srs := SixxShapeChangeReadStream on: oldSixx readStream.
srs shapeChangers at:#SmallIntegerOLD put: SmallInteger . "simple renaming"

srs shapeChangers at: #SixxShapeChangedObject put: SixxMockShapeChanger.
"You can implement ShapeChanger for more complex conversion."

---
[:masashi | ^umezawa]!

!SixxShapeChangeReadStream methodsFor: 'initializing' stamp: 'mu 6/6/2007 20:32'!
initialize
	super initialize.
	shapeChangeClassResolver := nil.

	self setUpContextDictionary ! !

!SixxShapeChangeReadStream methodsFor: 'initializing' stamp: 'mu 6/7/2007 19:14'!
setUpContextDictionary

	self contextDictionary at: #'SixxContextValue::CustomClassResolver' put: self shapeChangeClassResolver
	! !

!SixxShapeChangeReadStream methodsFor: 'accessing' stamp: 'mu 6/6/2007 20:32'!
shapeChangeClassResolver
	shapeChangeClassResolver ifNil: [shapeChangeClassResolver := SixxShapeChangeClassResolver new].
	^ shapeChangeClassResolver! !

!SixxShapeChangeReadStream methodsFor: 'accessing' stamp: 'mu 6/6/2007 20:32'!
shapeChangeClassResolver: anObject
	
	shapeChangeClassResolver := anObject! !

!SixxShapeChangeReadStream methodsFor: 'accessing' stamp: 'mu 6/6/2007 20:36'!
shapeChangers
	"shortcut - for returning global scoped (Smalltalk) shape changers"
	^self shapeChangeClassResolver shapeChangers! !

!SixxShapeChangeReadStream methodsFor: 'accessing' stamp: 'mu 6/6/2007 20:35'!
shapeChangers: shapeChangers

	self shapeChangeClassResolver putShapeChangers: shapeChangers ! !

Object subclass: #SixxSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

SixxSettings class
	instanceVariableNames: 'useCDATA useEnvironment useRecoveryRead useNCR'!

!SixxSettings class methodsFor: 'accessing' stamp: 'MU 9/2/2002 02:26'!
useCDATA
	useCDATA isNil ifTrue: [useCDATA := false].
	^useCDATA! !

!SixxSettings class methodsFor: 'accessing' stamp: 'MU 9/2/2002 02:26'!
useCDATA: aBoolean
	useCDATA := aBoolean! !

!SixxSettings class methodsFor: 'accessing' stamp: 'mu 3/30/2007 11:40'!
useCompactTags
	^SixxConstants useCompactTags! !

!SixxSettings class methodsFor: 'accessing' stamp: 'mu 3/30/2007 11:40'!
useCompactTags: aBoolean
	SixxConstants useCompactTags: aBoolean! !

!SixxSettings class methodsFor: 'accessing' stamp: 'MU 3/6/2003 12:55'!
useEnvironment
	useEnvironment isNil ifTrue: [useEnvironment := false].
	^useEnvironment! !

!SixxSettings class methodsFor: 'accessing' stamp: 'MU 3/6/2003 12:55'!
useEnvironment: aBoolean
	useEnvironment := aBoolean! !

!SixxSettings class methodsFor: 'accessing' stamp: 'mu 12/26/2006 11:04'!
useNCR
	useNCR ifNil: [useNCR := false].
	^useNCR! !

!SixxSettings class methodsFor: 'accessing' stamp: 'mu 12/26/2006 11:04'!
useNCR: aBoolean
	useNCR := aBoolean == true! !

!SixxSettings class methodsFor: 'accessing' stamp: 'mu 6/8/2007 09:17'!
useNormalTags
	^(self useCompactTags or: [self useReducedTags]) not! !

!SixxSettings class methodsFor: 'accessing' stamp: 'mu 6/8/2007 09:15'!
useNormalTags: aBoolean 
	self useCompactTags: aBoolean not.
	self useReducedTags: aBoolean not! !

!SixxSettings class methodsFor: 'accessing' stamp: 'MU 5/24/2003 18:32'!
useRecoveryRead
	useRecoveryRead isNil ifTrue: [useRecoveryRead := false].
	^useRecoveryRead! !

!SixxSettings class methodsFor: 'accessing' stamp: 'MU 5/24/2003 18:33'!
useRecoveryRead: aBoolean
	useRecoveryRead := aBoolean! !

!SixxSettings class methodsFor: 'accessing' stamp: 'mu 6/7/2007 19:23'!
useReducedTags
	^SixxConstants useReducedTags! !

!SixxSettings class methodsFor: 'accessing' stamp: 'mu 6/7/2007 19:22'!
useReducedTags: aBoolean
	SixxConstants useReducedTags: aBoolean! !

Object subclass: #SixxShapeChanger
	instanceVariableNames: 'shapeChangedObject attributesMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxShapeChanger commentStamp: 'mu 2/10/2007 23:30' prior: 0!
I can be used for reading shape-changed instances.

Basically, you should subclass me and override three methods.

(YourShapeChanger >> shapeChangedObjectClass)
 Return a newly introduced class for old instances.

(YourShapeChanger >> sixxInstVarNamed: varName put: value)
 Override this method for setting converted values to the shape changed object.
 Example:
	"#oldNamedVar1 inst var was renamed to #renamedAtt1"
	varName == #oldNamedVar1 ifTrue: [^self attributesMap at: #renamedAtt1 put: value].

	"#oldNamedVar2 inst var was removed."
	varName == #oldNamedVar2 ifTrue: [^self].

	super sixxInstVarNamed: varName put: value 

(YourShapeChanger >> initializeShapeChangedObject )
 Override this method for setting newly introduced values to the shape changed object.

---
[:masashi | ^umezawa]!

SixxShapeChanger subclass: #SixxMockShapeChanger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockShapeChanger methodsFor: 'override hooks' stamp: 'mu 6/5/2007 19:58'!
initializeShapeChangedObject
	
	"override"

	self shapeChangedObject addedAtt1: 22222.
	! !

!SixxMockShapeChanger methodsFor: 'override hooks' stamp: 'mu 12/22/2006 16:50'!
shapeChangedObjectClass

	"override"

	^SixxMockShapeChangedObjectWithoutShapeChangeMethods! !

!SixxMockShapeChanger methodsFor: 'override hooks' stamp: 'mu 1/15/2007 17:54'!
sixxInstVarNamed: varName put: value
	varName == #oldNamedVar1 ifTrue: [^self attributesMap at: #renamedAtt1 put: value].
	varName == #oldVar2 ifTrue: [^self].

	super sixxInstVarNamed: varName put: value! !

!SixxShapeChanger methodsFor: 'accessing' stamp: 'mu 12/22/2006 16:32'!
attributesMap
	"Answer the value of attributesMap"
	attributesMap isNil ifTrue: [attributesMap := Dictionary new].
	^ attributesMap! !

!SixxShapeChanger methodsFor: 'accessing' stamp: 'mu 12/22/2006 16:32'!
attributesMap: anObject
	
	attributesMap := anObject! !

!SixxShapeChanger methodsFor: 'override hooks' stamp: 'mu 6/23/2007 17:42'!
createShapeChangedObject
	"override if shapeChangedObjectClass does not understand #new"

	^self shapeChangedObjectClass new.
	! !

!SixxShapeChanger methodsFor: 'override hooks' stamp: 'mu 1/15/2007 17:24'!
initializeShapeChangedObject
	
	"By default, do nothing"
	"You can override this for initializing the shape changed object"

	! !

!SixxShapeChanger methodsFor: 'private' stamp: 'mu 6/23/2007 17:42'!
preInitShapeChangedObject

	"pre-initialize default values by attributesMap"

	self attributesMap
		keysAndValuesDo: [:key :value | self shapeChangedObject perform: (key , ':') asSymbol with: value].
	! !

!SixxShapeChanger methodsFor: 'accessing' stamp: 'mu 6/23/2007 19:59'!
shapeChangedObject
	"Answer the value of shapeChangedObject"
	shapeChangedObject isNil ifTrue: [
		shapeChangedObject := self createShapeChangedObject.
		self preInitShapeChangedObject.
		self initializeShapeChangedObject.
	].

	^ shapeChangedObject! !

!SixxShapeChanger methodsFor: 'override hooks' stamp: 'mu 12/22/2006 16:59'!
shapeChangedObjectClass

	"override"
	"Return the class of shape changed object"

	self subclassResponsibility! !

!SixxShapeChanger methodsFor: 'accessing' stamp: 'mu 12/22/2006 16:24'!
shapeChangedObject: anObject
	
	shapeChangedObject := anObject! !

!SixxShapeChanger methodsFor: 'override hooks' stamp: 'mu 1/15/2007 17:15'!
sixxInstVarNamed: varName put: value
	
	"override"
	"You can override this for setting values to the shape changed object like:
		(YourShapeChanger >> sixxInstVarNamed: varName put: value)
			varName == #oldNamedVar1 ifTrue: [^self attributesMap at: #renamedAtt1 put: value].
			super sixxInstVarNamed: varName put: value "

	self attributesMap at: varName asString put: value! !

!SixxShapeChanger methodsFor: 'accessing' stamp: 'mu 12/22/2006 16:29'!
sixxReadValue
	
	^self shapeChangedObject! !

Object subclass: #SixxWriteStream
	instanceVariableNames: 'stream contextDictionary isStartTagPut isEndTagPut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxWriteStream commentStamp: '<historical>' prior: 0!
I represent a WriteStream for SIXX format.

I can be used as follows:

srs := SixxWriteStream newFileNamed: ('obj.sixx').
srs nextPut: <object>.
srs close.

srs := SixxWriteStream newFileNamed: ('objs.sixx').
srs nextPutAll: <collection of object>.
srs close.

---
[:masashi | ^umezawa]!

!SixxWriteStream class methodsFor: 'instance creation' stamp: 'MU 5/31/2002 11:20'!
new
	^super new initialize! !

!SixxWriteStream class methodsFor: 'instance creation' stamp: 'kuri-t 5/17/2002 12:29'!
newFileNamed: fileName 
	^ self new newFileNamed: fileName! !

!SixxWriteStream class methodsFor: 'instance creation' stamp: 'kuri-t 5/31/2002 16:42'!
onWithDeclaration: writeStream 
	^ (self on: writeStream) xmlDeclaration! !

!SixxWriteStream class methodsFor: 'instance creation' stamp: 'kuri-t 5/31/2002 16:42'!
on: writeStream 
	^ self new on: writeStream! !

!SixxWriteStream methodsFor: 'file open/close' stamp: 'MU 5/31/2002 11:45'!
close
	self endTag.
	self stream close
! !

!SixxWriteStream methodsFor: 'actions' stamp: 'mu 7/30/2006 22:03'!
contents
	^self close; rawContents! !

!SixxWriteStream methodsFor: 'accessing' stamp: 'MU 5/31/2002 11:35'!
contextDictionary

	^contextDictionary! !

!SixxWriteStream methodsFor: 'accessing' stamp: 'MU 5/31/2002 11:35'!
contextDictionary: aValue

	contextDictionary := aValue! !

!SixxWriteStream methodsFor: 'writing' stamp: 'kuri-t 5/17/2002 13:56'!
cr
	self stream cr! !

!SixxWriteStream methodsFor: 'writing' stamp: 'mu 3/29/2007 22:49'!
endTag
	(self isStartTagPut and: [ self isEndTagPut not] )
		ifTrue: [self stream nextPutAll: SixxConstants current sixxEndTag.
			self isEndTagPut: true]! !

!SixxWriteStream methodsFor: 'initializing' stamp: 'MU 5/31/2002 11:34'!
initialize
	contextDictionary := IdentityDictionary new.
	isStartTagPut := false.
	isEndTagPut := false. 
	! !

!SixxWriteStream methodsFor: 'accessing' stamp: 'MU 5/31/2002 11:35'!
isEndTagPut

	^isEndTagPut! !

!SixxWriteStream methodsFor: 'accessing' stamp: 'MU 5/31/2002 11:35'!
isEndTagPut: aValue

	isEndTagPut := aValue! !

!SixxWriteStream methodsFor: 'accessing' stamp: 'MU 5/31/2002 11:35'!
isStartTagPut

	^isStartTagPut! !

!SixxWriteStream methodsFor: 'accessing' stamp: 'MU 5/31/2002 11:35'!
isStartTagPut: aValue

	isStartTagPut := aValue! !

!SixxWriteStream methodsFor: 'initializing' stamp: 'MU 6/14/2002 11:59'!
newFileNamed: fileName 
	stream := SixxPortableUtil writeFileStreamNamed: fileName.
	self initialize! !

!SixxWriteStream methodsFor: 'writing' stamp: 'kuri-t 5/17/2002 14:31'!
nextPutAll: aCollection 
	aCollection
		do: [:obj | self nextPut: obj]! !

!SixxWriteStream methodsFor: 'writing' stamp: 'MU 5/31/2002 11:45'!
nextPut: anObject 
	self startTag.
	anObject
		sixxOn: self stream
		indent: 1
		context: self contextDictionary! !

!SixxWriteStream methodsFor: 'initializing' stamp: 'MU 5/31/2002 11:19'!
on: aStream
	stream := aStream.
	! !

!SixxWriteStream methodsFor: 'actions' stamp: 'MU 5/31/2002 11:53'!
rawContents
	^self stream contents
! !

!SixxWriteStream methodsFor: 'writing' stamp: 'mu 3/29/2007 22:48'!
startTag
	self isStartTagPut
		ifFalse: [self stream nextPutAll: SixxConstants current sixxStartTag.
			self isStartTagPut: true.
			self cr]! !

!SixxWriteStream methodsFor: 'accessing' stamp: 'MU 5/31/2002 11:35'!
stream

	^stream! !

!SixxWriteStream methodsFor: 'accessing' stamp: 'MU 5/31/2002 11:35'!
stream: aValue

	stream := aValue! !

!SixxWriteStream methodsFor: 'writing' stamp: 'mu 3/29/2007 22:48'!
xmlDeclaration
	self stream nextPutAll: SixxConstants current xmlDeclaration; cr! !

Object subclass: #SixxXmlParserAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-ParserAdapter'!

SixxXmlParserAdapter subclass: #SixxVwXmlParserAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-ParserAdapter'!

!SixxVwXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:48'!
attributeAt: attributeName from: sixxElement
	| attr |
	attr := sixxElement attributes
				detect: [:each | each key type = attributeName]
				ifNone: [^ nil].
	^ attr value! !

!SixxVwXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:51'!
characterDataFrom: sixxElement
	^ sixxElement characterData! !

!SixxVwXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'MU 5/23/2002 17:37'!
elementsFrom: sixxElement 
	^sixxElement elements select: [:each | each isText not]
! !

!SixxVwXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/20/2002 14:51'!
nameFrom: sixxElement 
	^ sixxElement tag type! !

!SixxVwXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/16/2002 14:41'!
parseXml: xmlStringOrStream 
	| stream parser |
	stream := xmlStringOrStream isStream
				ifTrue: [xmlStringOrStream]
				ifFalse: [ReadStream on: xmlStringOrStream].
	parser := VWXMLXMLParser on: stream.
	parser validate: false.
	^ parser scanDocument root! !

!SixxXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:46'!
attributeAt: attributeName from: sixxElement
	self subclassResponsibility! !

!SixxXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:51'!
characterDataFrom: sixxElement
	self subclassResponsibility! !

!SixxXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:46'!
elementsFrom: sixxElement
	self subclassResponsibility! !

!SixxXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'MU 5/23/2002 17:38'!
isTextFrom: sixxElement
	^ sixxElement isText! !

!SixxXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/20/2002 19:23'!
nameFrom: sixxElement
	self subclassResponsibility! !

!SixxXmlParserAdapter class methodsFor: 'actions' stamp: 'kuri-t 5/16/2002 14:29'!
parseXml: xmlStringOrStream
	self subclassResponsibility! !

SixxXmlParserAdapter subclass: #SixxYaxoXmlParserAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-ParserAdapter'!

!SixxYaxoXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:44'!
attributeAt: attributeName from: sixxElement
	^ sixxElement attributeAt: attributeName! !

!SixxYaxoXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:51'!
characterDataFrom: sixxElement
	^ sixxElement contentString! !

!SixxYaxoXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'MU 5/23/2002 17:38'!
elementsFrom: sixxElement 
	^sixxElement elements
		! !

!SixxYaxoXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/20/2002 14:53'!
nameFrom: sixxElement
	^ sixxElement name! !

!SixxYaxoXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/16/2002 14:41'!
parseXml: xmlStringOrStream 
	| stream |
	stream := xmlStringOrStream isStream
				ifTrue: [xmlStringOrStream]
				ifFalse: [ReadStream on: xmlStringOrStream].
	^ (XMLDOMParser parseDocumentFrom: stream) topElement! !

Object subclass: #SixxXmlUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

SixxXmlUtil class
	instanceVariableNames: 'convertCharDict parserAdapter settings'!

!SixxXmlUtil class methodsFor: 'actions' stamp: 'MU 4/19/2002 18:03'!
asXmlText: aString 
	|  wStr |
	wStr := WriteStream
				on: (String new: aString size).
	^(self writeXmlText: aString on: wStr) contents! !

!SixxXmlUtil class methodsFor: 'actions-parse' stamp: 'kuri-t 5/16/2002 12:12'!
attributeAt: attributeName from: sixxElement 
	^ self parserAdapter attributeAt: attributeName from: sixxElement! !

!SixxXmlUtil class methodsFor: 'actions' stamp: 'mu 3/29/2007 23:07'!
attributeSymbolAt: attribName from: sixxElement
	| value |
	(self isTextFrom: sixxElement) ifTrue: [^nil].
	value := self attributeAt: attribName from: sixxElement .
	^ value isNil
		ifFalse: [value asSymbol]! !

!SixxXmlUtil class methodsFor: 'actions-parse' stamp: 'kuri-t 5/16/2002 12:12'!
characterDataFrom: sixxElement
	^ self parserAdapter characterDataFrom: sixxElement! !

!SixxXmlUtil class methodsFor: 'actions' stamp: 'mu 4/5/2007 11:29'!
contentsWithEmptyTagNamed: tagName do: block 
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPut: $<;
		nextPutAll: tagName;
		space.
	block value: wStr.
	wStr nextPut:$/;
		nextPut: $>.
	^ wStr contents! !

!SixxXmlUtil class methodsFor: 'actions' stamp: 'mu 3/30/2007 10:34'!
contentsWithEndTagNamed: tagName
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '</';
		nextPutAll: tagName;
		nextPut: $>.
	^wStr contents! !

!SixxXmlUtil class methodsFor: 'actions' stamp: 'mu 3/30/2007 10:33'!
contentsWithStartTagNamed: tagName do: block 
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPut: $<;
		nextPutAll: tagName;
		space.
	block value: wStr.
	wStr nextPut: $>.
	^ wStr contents! !

!SixxXmlUtil class methodsFor: 'actions' stamp: 'MU 4/19/2002 18:08'!
contentsWithXmlDeclaration: aString 
	| wStr |
	wStr := WriteStream
				on: (String new: 1024).
	wStr nextPutAll: self xmlDeclaration.
	2
		timesRepeat: [wStr nextPut: Character cr.
			wStr nextPut: Character lf].
	wStr nextPutAll: aString.
	^ wStr contents! !

!SixxXmlUtil class methodsFor: 'accessing' stamp: 'MU 4/19/2002 18:03'!
convertCharDict
	^convertCharDict! !

!SixxXmlUtil class methodsFor: 'private' stamp: 'mu 11/4/2006 10:15'!
convertWriteXmlText: aString on: aWriteStream
	| cDict wStr |
	cDict := self convertCharDict.
	wStr := aWriteStream.
	aString
		do: [:eachChar | 
			| val | 
			val := (SixxPortableUtil charCodeOf: eachChar).
			val >= 127
				ifTrue: [self writeUnicodeChar: eachChar on: wStr]
				ifFalse: [| conv | 
					conv := cDict
								at: val
								ifAbsent: [].
					conv isNil
						ifTrue: [wStr nextPut: eachChar]
						ifFalse: [wStr nextPutAll: conv]]].
	^wStr! !

!SixxXmlUtil class methodsFor: 'actions-parse' stamp: 'kuri-t 5/16/2002 12:12'!
elementsFrom: sixxElement
	^ self parserAdapter elementsFrom: sixxElement! !

!SixxXmlUtil class methodsFor: 'private-initialize' stamp: 'mu 12/26/2006 10:55'!
initConvertCharDict
	convertCharDict := Dictionary new.
	0 to: 47 do: [:each | convertCharDict at: each put: '&#', each asString, ';'].
	convertCharDict 
		at: $& asciiValue put: '&amp;';
		at: $< asciiValue put: '&lt;';
		at: $> asciiValue put: '&gt;';
		at: $' asciiValue put: '&apos;';
		at: $" asciiValue put: '&quot;'.
	convertCharDict 
		removeKey: Character space asciiValue;
		removeKey: Character tab asciiValue;
		removeKey: Character cr asciiValue;
		removeKey: Character lf asciiValue.
	convertCharDict 
		removeKey: $/ asciiValue;
		removeKey: $+ asciiValue;
		removeKey: $- asciiValue;
		removeKey: $. asciiValue.! !

!SixxXmlUtil class methodsFor: 'class initialization' stamp: 'mu 12/26/2006 10:53'!
initialize
	"SixxXmlUtil initialize"
	self initConvertCharDict.
	parserAdapter := nil.
	settings := nil! !

!SixxXmlUtil class methodsFor: 'actions-parse' stamp: 'kuri-t 5/16/2002 12:12'!
isTextFrom: sixxElement
	^ self parserAdapter isTextFrom: sixxElement! !

!SixxXmlUtil class methodsFor: 'actions-parse' stamp: 'kuri-t 5/20/2002 14:53'!
nameFrom: sixxElement 
	^ self parserAdapter nameFrom: sixxElement! !

!SixxXmlUtil class methodsFor: 'accessing' stamp: 'kuri-t 5/16/2002 12:09'!
parserAdapter
	parserAdapter isNil
		ifTrue: [parserAdapter := (self environment includesKey: #XMLDOMParser)
						ifTrue: [self environment at: #SixxYaxoXmlParserAdapter]
						ifFalse: [(self environment includesKey: #VWXMLXMLParser)
								ifTrue: [self environment at: #SixxVwXmlParserAdapter]]].
	^ parserAdapter! !

!SixxXmlUtil class methodsFor: 'accessing' stamp: 'kuri-t 5/16/2002 12:10'!
parserAdapter: aSixxXmlParserAdapter 
	parserAdapter := aSixxXmlParserAdapter! !

!SixxXmlUtil class methodsFor: 'actions' stamp: 'MU 6/11/2003 17:24'!
parseXml: xmlStringOrStream 
	^[self parserAdapter parseXml: xmlStringOrStream] on: Error
		do: [:ex | SixxPortableUtil signalException: (SixxXmlParseError originalError: ex)]! !

!SixxXmlUtil class methodsFor: 'accessing' stamp: 'mu 12/26/2006 10:49'!
settings
	settings isNil
		ifTrue: [settings := Smalltalk
						at: #SixxSettings
						ifAbsent: [self error: 'SixxSettings is needed to run SIXX']].
	^ settings! !

!SixxXmlUtil class methodsFor: 'actions' stamp: 'mu 3/30/2007 10:25'!
writeAttribute: attName value: attValue on: aWriteStream 
	attValue isNil ifTrue: [^self].
	aWriteStream nextPutAll: attName;
		 nextPutAll: '="';
		 nextPutAll: attValue;
		 nextPutAll: '" '.
	^aWriteStream! !

!SixxXmlUtil class methodsFor: 'private' stamp: 'mu 12/26/2006 11:06'!
writeUnicodeChar: aCharacter on: aWriteStream 
	self settings useNCR
		ifTrue: [aWriteStream nextPutAll: '&#';
				 nextPutAll: (SixxPortableUtil charCodeOf: aCharacter) printString;
				 nextPut: $;]
		ifFalse: [aWriteStream nextPut: aCharacter]! !

!SixxXmlUtil class methodsFor: 'actions' stamp: 'mu 12/26/2006 10:50'!
writeXmlText: aString on: aWriteStream 
	self settings useCDATA
		ifTrue: [aWriteStream nextPutAll: '<!![CDATA['.
			aWriteStream nextPutAll: aString.
			aWriteStream nextPutAll: ']]>']
		ifFalse: [self convertWriteXmlText: aString on: aWriteStream].
	^aWriteStream! !

!IntegerArray class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:19'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| col |
	col := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	^ col asIntegerArray! !

!IntegerArray methodsFor: '*sixx-printing' stamp: 'MU 6/29/2002 16:03'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: '#( '.
	self do:[:each | aStream nextPutAll: each printString; space].
	aStream nextPutAll: ')'.! !

!Date class methodsFor: '*sixx-instance creation' stamp: 'mu 1/16/2007 11:26'!
createInstanceOf: aClass withSixxElement: sixxElement
	^self readSixxContentStringFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!Date class methodsFor: '*sixx-private' stamp: 'mu 1/16/2007 11:27'!
readSixxContentStringFrom: aStream
	"Squeak specific"
	^ self readFrom: aStream! !

!Date methodsFor: '*sixx-printing' stamp: 'MU 9/16/2002 22:29'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxContentString! !

!Date methodsFor: '*sixx-private' stamp: 'MU 9/16/2002 22:28'!
sixxContentString
	"Squeak Specific"
	^self printString! !

!Color class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:22'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!Color methodsFor: '*sixx-printing' stamp: 'kuri-t 5/14/2002 14:19'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: self storeString! !

TestCase subclass: #SixxAbstractTestCase
	instanceVariableNames: 'originalUseEnvironment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxAbstractTestCase methodsFor: 'running' stamp: 'mu 12/19/2006 18:40'!
setUp
	originalUseEnvironment := SixxSettings useEnvironment.
	SixxSettings useEnvironment: false! !

!SixxAbstractTestCase methodsFor: 'running' stamp: 'mu 12/19/2006 18:40'!
tearDown
	SixxSettings useEnvironment: originalUseEnvironment! !

SixxAbstractTestCase subclass: #SixxConstantsTestCase
	instanceVariableNames: 'oldSixxConstants'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxConstantsTestCase methodsFor: 'accessing' stamp: 'kuri-t 5/21/2002 19:12'!
oldSixxConstants
	^ oldSixxConstants! !

!SixxConstantsTestCase methodsFor: 'accessing' stamp: 'kuri-t 5/21/2002 19:13'!
oldSixxConstants: aSixxConstants
	oldSixxConstants := aSixxConstants! !

!SixxConstantsTestCase methodsFor: 'running' stamp: 'mu 3/29/2007 22:47'!
setUp
	^ self oldSixxConstants: SixxConstants current! !

!SixxConstantsTestCase methodsFor: 'running' stamp: 'mu 3/29/2007 22:47'!
tearDown
	SixxConstants initialize.
	SixxConstants current xmlVersion: self oldSixxConstants xmlVersion.
	SixxConstants current xmlEncoding: self oldSixxConstants xmlEncoding.
	SixxConstants current sixxVersion: self oldSixxConstants sixxVersion! !

!SixxConstantsTestCase methodsFor: 'tests' stamp: 'mu 6/23/2007 19:40'!
testDetectConstants
	"SixxConstantsTestCase debug: #testDetectConstants"
	| sixx rixx cixx |
	sixx :=  '<sixx><sixx.object sixx.id="0" sixx.type="Array" ><sixx.object sixx.id="1" sixx.type="SmallInteger" >1</sixx.object></sixx.object></sixx>'.
	rixx :=  '<rixx><object id="0" type="Array" ><object id="1" type="SmallInteger" >1</object></object></rixx>'.
	cixx :=  '<cixx><o i="0" t="Array" ><o i="1" t="SmallInteger" >1</o></o></cixx>'.


	SixxConstants setCurrentConstantsBy: (SixxXmlUtil parseXml: sixx).
	self should: [SixxConstants current class = SixxConstants].

	SixxConstants setCurrentConstantsBy: (SixxXmlUtil parseXml: rixx).
	self should: [SixxConstants current class = SixxReducedConstants].

	SixxConstants setCurrentConstantsBy: (SixxXmlUtil parseXml: cixx).
	self should: [SixxConstants current class = SixxCompactConstants].! !

!SixxConstantsTestCase methodsFor: 'tests' stamp: 'mu 6/23/2007 19:41'!
testDetectConstantsNoRoot
	"SixxConstantsTestCase debug: #testDetectConstantsNoRoot"
	| sixx rixx cixx |
	sixx :=  '<sixx.object sixx.id="0" sixx.type="Array" ><sixx.object sixx.id="1" sixx.type="SmallInteger" >1</sixx.object></sixx.object>'.
	rixx :=  '<object id="0" type="Array" ><object id="1" type="SmallInteger" >1</object></object>'.
	cixx :=  '<o i="0" t="Array" ><o i="1" t="SmallInteger" >1</o></o>'.


	SixxConstants setCurrentConstantsBy: (SixxXmlUtil parseXml: sixx).
	self should: [SixxConstants current class = SixxConstants].

	SixxConstants setCurrentConstantsBy: (SixxXmlUtil parseXml: rixx).
	self should: [SixxConstants current class = SixxReducedConstants].

	SixxConstants setCurrentConstantsBy: (SixxXmlUtil parseXml: cixx).
	self should: [SixxConstants current class = SixxCompactConstants].! !

!SixxConstantsTestCase methodsFor: 'tests' stamp: 'mu 3/29/2007 22:47'!
testInitialize
	SixxConstants initialize.
	self
		should: [SixxConstants current xmlVersion = '1.0'].
	self
		should: [SixxConstants current xmlEncoding = 'utf-8'].
	self
		should: [SixxConstants current sixxVersion = '1.0']! !

!SixxConstantsTestCase methodsFor: 'tests' stamp: 'mu 3/29/2007 22:47'!
testSixxStartTag
	SixxConstants initialize.
	self
		should: [SixxConstants current sixxStartTag = '<sixx sixx.version="1.0">'].
	SixxConstants current sixxVersion: '2.0'.
	self
		should: [SixxConstants current sixxStartTag = '<sixx sixx.version="2.0">']! !

!SixxConstantsTestCase methodsFor: 'tests' stamp: 'mu 3/29/2007 22:47'!
testXmlDeclaration
	SixxConstants initialize.
	self
		should: [SixxConstants current xmlDeclaration = '<?xml version="1.0" encoding="utf-8"?>'].
	SixxConstants current xmlVersion: '3.0'.
	SixxConstants current xmlEncoding: 'sjis'.
	self
		should: [SixxConstants current xmlDeclaration = '<?xml version="3.0" encoding="sjis"?>']! !

SixxAbstractTestCase subclass: #SixxCustomObjectSerializationTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxCustomObjectSerializationTestCase commentStamp: 'mu 12/17/2006 22:38' prior: 0!
SixxCustomObjectSerializationTestCase suite run!

!SixxCustomObjectSerializationTestCase methodsFor: 'tests' stamp: 'mu 12/17/2006 22:24'!
testIgnorableInstVarNames
	"self debug: #testIgnorableInstVarNames"
	| obj readObject|
	obj := SixxMockObjectWithCache new.
	obj att1: 1.
	obj att2: 2.
	obj cache1: 'cache1'.	
	obj cache2: 'cache2'.

	readObject := Object readSixxFrom: obj sixxString.
	self should: [readObject att1 = 1].	
	self should: [readObject att2 = 2].	
	self should: [readObject cache1 = nil].	
	self should: [readObject cache2 = nil].	! !

!SixxCustomObjectSerializationTestCase methodsFor: 'tests' stamp: 'mu 12/17/2006 22:28'!
testReadSixxWriteValueAndSixxReadValue
	"self debug: #testReadSixxWriteValueAndSixxReadValue"

	| object now sixx parsedNode readObject |
	object := SixxMockCustomWriteObject new.
	object name: 'This is a test'.
	now := Time now.
	object time: now.
	sixx := object sixxString.
	parsedNode := SixxXmlUtil parseXml: sixx.
	self shouldnt: [(SixxXmlUtil attributeAt: 'sixx.type' from: parsedNode) = 'SixxMockCustomWriteObject'].
	self should: [(SixxXmlUtil attributeAt: 'sixx.type' from: parsedNode) = 'SixxMockMementoArray'].

	readObject := Object readSixxFrom: sixx.
	self shouldnt: [readObject class = SixxMockMementoArray].
	self should: [readObject class = SixxMockCustomWriteObject].

	self should: [readObject name = 'This is a test'].	
	self should: [readObject time = now]
! !

!SixxCustomObjectSerializationTestCase methodsFor: 'tests' stamp: 'mu 3/23/2007 11:04'!
testSameSixxWriteValueAndSixxReadValue
	"SixxCustomObjectSerializationTestCase debug: #testSameSixxWriteValueAndSixxReadValue"

	| obj1 array array2 |
	obj1 := SixxMockCustomWriteObject new name: 'aa'; time: Time now.
	array := Array with:obj1 with:obj1.

	array2 := Object readSixxFrom: array sixxString.
	self should: [(array2 at: 1) = (array2 at: 2)].! !

!SixxCustomObjectSerializationTestCase methodsFor: 'tests' stamp: 'mu 3/23/2007 11:44'!
testSharedSixxWriteValueAndSixxReadValue
	"SixxCustomObjectSerializationTestCase debug: #testSharedSixxWriteValueAndSixxReadValue"
	| object1 now1 object2 now2 parsedNode array sixx readArray inArray readObject1 readObject2 |
	object1 := SixxMockCustomWriteObject new.
	object1 name: 'This is a test'.
	now1 := Time now.
	object1 time: now1.

	object2 := SixxMockCustomWriteObject new.
	object2 name: 'This is a test2'.
	now2 := Time fromSeconds: now1 asSeconds + 10.
	object2 time: now2.
	
	parsedNode := SixxXmlUtil parseXml: object1 sixxString.
	self should: [(SixxXmlUtil attributeAt: 'sixx.type' from: parsedNode) = 'SixxMockMementoArray'].

	array := Array with: object1 with: object2 with: (Array with: object1 with: object2 with: 3).
	sixx := array sixxString.
	readArray := Object readSixxFrom: sixx.
	inArray := readArray at: 3.

	self should: [(readArray at: 1) = (inArray at: 1)].
	self should: [(readArray at: 2) = (inArray at: 2)].
	self shouldnt: [(readArray at: 3) = (Array with: object1 with: object2 with: 3)].
	
	readObject1 := readArray at: 1.
	self should: [readObject1 name = 'This is a test'].	
	self should: [readObject1 time = now1].

	readObject2 := readArray at: 2.
	self should: [readObject2 name = 'This is a test2'].	
	self should: [readObject2 time = now2]
! !

!SixxCustomObjectSerializationTestCase methodsFor: 'tests' stamp: 'mu 12/17/2006 22:38'!
testSixxInitialize
	"self debug: #testSixxInitialize"
	| obj readObject|
	obj := SixxMockObjectInitializingOnRead new.
	obj att1: 1.
	obj att2: 2.
	obj cache1: 'cache1'.	
	obj cache2: 'cache2'.

	readObject := Object readSixxFrom: obj sixxString.
	self should: [readObject att1 = 1].	
	self should: [readObject att2 = 2].	
	self should: [readObject cache1 = 1234567].	
	self should: [readObject cache2 = 'this is cache2'].	! !

!SixxCustomObjectSerializationTestCase methodsFor: 'tests' stamp: 'mu 12/17/2006 22:35'!
testSixxPrepareWrite
	"self debug: #testSixxPrepareWrite"
	| obj readObject|
	obj := SixxMockObjectPreparingOnWrite new.
	obj att1: 1.
	obj att2: 2.
	obj cache1: 'cache1'.	
	obj cache2: 'cache2'.

	readObject := Object readSixxFrom: obj sixxString.
	self should: [readObject att1 = '1'].	
	self should: [readObject att2 = 4].	
	self should: [readObject cache1 = nil].	
	self should: [readObject cache2 = nil].	! !

SixxAbstractTestCase subclass: #SixxGeneratingTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxGeneratingTestCase methodsFor: 'private' stamp: 'mu 4/18/2007 07:43'!
isSameContentsDictionary: dictA with: dictB
	dictA size = dictB size ifFalse: [^false].

	dictA keysAndValuesDo: [:keyA :valueA |
		((dictB at: keyA) storeString = valueA storeString) ifFalse: [^false]
	].

	^true! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 4/17/2007 23:09'!
testCompactSixxStringForCompositeDictionary

	"SixxGeneratingTestCase debug: #testCompactSixxStringForCompositeDictionary"
	
	| originalSettings dic childDic expected |
	originalSettings := SixxSettings useCompactTags.
	[SixxSettings useCompactTags: true.
	
	expected := '<o i="0" t="Dictionary" >
	<o i="1" t="Association" >
		<o i="2" n="key" t="Symbol" >parent1</o>
		<o i="3" n="value" t="String" >sample string.</o>
	</o>
	<o i="4" t="Association" >
		<o i="5" n="key" t="Symbol" >parent4</o>
		<o i="6" n="value" t="Dictionary" >
			<o i="7" t="Association" >
				<o i="8" n="key" t="Symbol" >child1</o>
				<o i="9" n="value" t="String" >abcde</o>
			</o>
		</o>
	</o>
	<o i="10" t="Association" >
		<o i="11" n="key" t="Symbol" >parent3</o>
		<o i="12" n="value" t="Array" >
			<o i="13" t="SmallInteger" >10</o>
			<o i="14" t="SmallInteger" >20</o>
			<o i="15" t="SmallInteger" >30</o>
		</o>
	</o>
	<o i="16" t="Association" >
		<o i="17" n="key" t="Symbol" >parent2</o>
		<o i="18" n="value" t="SmallInteger" >100</o>
	</o>
</o>
'.
	childDic := Dictionary new.
	childDic at: #child1 put: 'abcde'.
	dic := Dictionary new.
	dic at: #parent1 put: 'sample string.'.
	dic at: #parent2 put: 100.
	dic at: #parent3 put: #(10 20 30 ).
	dic at: #parent4 put: childDic.
	self
		should: [self isSameContentsDictionary: (Object readSixxFrom: dic sixxString) with: (Object readSixxFrom: expected)].
		
	] ensure: [SixxSettings useCompactTags: originalSettings]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 4/2/2007 23:43'!
testCompactSixxStringForRunArray

	"SixxGeneratingTestCase debug: #testCompactSixxStringForRunArray"
	
	| originalSettings arr expectedStr |
	originalSettings := SixxSettings useCompactTags.
	[SixxSettings useCompactTags: true.
	
	expectedStr := '<o i="0" t="RunArray" >
	<o i="1" n="runs" t="Array" >
		<o i="2" t="SmallInteger" >1</o>
		<o i="3" t="SmallInteger" >2</o>
		<o r="2" ></o>
	</o>
	<o i="4" n="values" t="Array" >
		<o r="2" ></o>
		<o r="3" ></o>
		<o i="5" t="SmallInteger" >3</o>
	</o>
</o>
'.

	arr := RunArray runs: #(1 2 1) values: #(1 2 3).
	self should: [arr sixxString = expectedStr]
	
	] ensure: [SixxSettings useCompactTags: originalSettings].! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:01'!
testSixxStringForArray
	| arr expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	arr := Array new: 3.
	arr at: 1 put: 10.
	arr at: 2 put: 20.
	arr at: 3 put: 30.
	self
		should: [arr sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 6/25/2004 01:40'!
testSixxStringForBag
	| bag result |
	bag := Bag new.
	bag add: 10.
	bag add: 20.
	bag add: 30.
	bag add: 30.
	result := Object readSixxFrom: bag sixxString.
	self
		should: [result size = 4].
	self
		should: [result includes: 10].
	self
		should: [result includes: 20].
	self
		should: [result includes: 30].
	self
		should: [(result occurrencesOf: 30) = 2]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 4/5/2007 11:31'!
testSixxStringForBoolean
	| expectedStr |
	expectedStr := '<sixx.object sixx.type="True" />
'.
	self
		should: [true sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 6/26/2004 12:19'!
testSixxStringForByteArray
	| expectedStr |
	expectedStr :=  '<sixx.object sixx.id="0" sixx.type="ByteArray" >0A141E</sixx.object>
'.
	self
		should: [(ByteArray with: 10 with: 20 with: 30) sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:02'!
testSixxStringForCharacter
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Character" >$A</sixx.object>
'.
	self
		should: [$A sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:05'!
testSixxStringForClass
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="SixxMockClassForUnitTest class" >
	<sixx.object sixx.id="1" sixx.name="instVar1" sixx.type="String" >value1</sixx.object>
	<sixx.object sixx.id="2" sixx.name="instVar2" sixx.type="String" >value2</sixx.object>
	<sixx.object sixx.id="3" sixx.name="instVar3" sixx.type="String" >value3</sixx.object>
</sixx.object>
'.
	SixxMockClassForUnitTest instVar1: 'value1'.
	SixxMockClassForUnitTest instVar2: 'value2'.
	SixxMockClassForUnitTest instVar3: 'value3'.
	self
		should: [SixxMockClassForUnitTest sixxString = expectedStr]
! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:06'!
testSixxStringForColor
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Color" >(Color r: 0.0 g: 0.0 b: 1.0)</sixx.object>
'.
	self
		should: [Color blue sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 4/17/2007 23:08'!
testSixxStringForCompositeDictionary
	"SixxGeneratingTestCase debug: #testSixxStringForCompositeDictionary"
	| dic childDic expected |
	expected := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >parent1</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="String" >sample string.</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >parent4</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="Dictionary" >
			<sixx.object sixx.id="7" sixx.type="Association" >
				<sixx.object sixx.id="8" sixx.name="key" sixx.type="Symbol" >child1</sixx.object>
				<sixx.object sixx.id="9" sixx.name="value" sixx.type="String" >abcde</sixx.object>
			</sixx.object>
		</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="10" sixx.type="Association" >
		<sixx.object sixx.id="11" sixx.name="key" sixx.type="Symbol" >parent3</sixx.object>
		<sixx.object sixx.id="12" sixx.name="value" sixx.type="Array" >
			<sixx.object sixx.id="13" sixx.type="SmallInteger" >10</sixx.object>
			<sixx.object sixx.id="14" sixx.type="SmallInteger" >20</sixx.object>
			<sixx.object sixx.id="15" sixx.type="SmallInteger" >30</sixx.object>
		</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="16" sixx.type="Association" >
		<sixx.object sixx.id="17" sixx.name="key" sixx.type="Symbol" >parent2</sixx.object>
		<sixx.object sixx.id="18" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
</sixx.object>
'.
	childDic := Dictionary new.
	childDic at: #child1 put: 'abcde'.
	dic := Dictionary new.
	dic at: #parent1 put: 'sample string.'.
	dic at: #parent2 put: 100.
	dic at: #parent3 put: #(10 20 30 ).
	dic at: #parent4 put: childDic.
	self
		should: [self isSameContentsDictionary: (Object readSixxFrom: dic sixxString) with: (Object readSixxFrom: expected)]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:14'!
testSixxStringForDate
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Date" >14 May 2002</sixx.object>
'.
	self
		should: [(Date
				newDay: 14
				month: 5
				year: 2002) sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 7/20/2006 15:57'!
testSixxStringForDateAndTime
	"self debug: #testSixxStringForDateAndTime"
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="DateAndTime" >2006-07-19T03:45:06+00:00</sixx.object>
'.
	self
		should: [(DateAndTime year: 2006 day: 200 hour: 3 minute: 45 second: 6) sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 4/18/2007 07:49'!
testSixxStringForDictionary
	| dic expected |
	expected := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="String" >value2</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object sixx.id="8" sixx.name="key" sixx.type="Symbol" >key3</sixx.object>
		<sixx.object sixx.id="9" sixx.name="value" sixx.type="String" >value3</sixx.object>
	</sixx.object>
</sixx.object>
'.
	dic := Dictionary new.
	dic at: #key1 put: 'value1'.
	dic at: #key2 put: 'value2'.
	dic at: #key3 put: 'value3'.
	self
		should: [self isSameContentsDictionary: (Object readSixxFrom: dic sixxString) with: (Object readSixxFrom: expected)]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 5/4/2007 13:18'!
testSixxStringForFraction
	"SixxGeneratingTestCase debug: #testSixxStringForFraction"
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Fraction" >(3/4)</sixx.object>
'.
	self
		should: [(3 / 4) sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'minami 3/18/2003 01:36'!
testSixxStringForInterval
	| interval expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Interval" >(1 to: 10 by: 3)</sixx.object>
'.
	interval := 1 to: 10 by: 3.
	self should: [interval sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:18'!
testSixxStringForNumber
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Fraction" >(3/4)</sixx.object>
'.
	self
		should: [(3 / 4) sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 6/24/2007 17:10'!
testSixxStringForObjectWithId
	"SixxGeneratingTestCase debug: #testSixxStringForObjectWithId"
	| expectedStr a b array |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="a" sixx.type="SixxMockObjectWithId" >
		<sixx.object sixx.id="2" sixx.name="id" sixx.type="String" >a</sixx.object>
		<sixx.object sixx.id="3" sixx.name="data" sixx.type="String" >aaa</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="b" sixx.type="SixxMockObjectWithId" >
		<sixx.object sixx.id="5" sixx.name="id" sixx.type="String" >b</sixx.object>
		<sixx.object sixx.id="6" sixx.name="data" sixx.type="String" >bbb</sixx.object>
	</sixx.object>
	<sixx.object sixx.idref="a" ></sixx.object>
</sixx.object>
'.

	a := SixxMockObjectWithId id: 'a'.
	a data: 'aaa'.
	b := SixxMockObjectWithId id: 'b'.
	b data: 'bbb'.
	array := Array with: a with: b with: a.

	self
		should: [array sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:18'!
testSixxStringForOrdredCollection
	| expectedStr col |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="OrderedCollection" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	col := OrderedCollection new.
	col add: 10.
	col add: 20.
	col add: 30.
	self
		should: [col sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 12/12/2006 19:47'!
testSixxStringForRectangle
	"SixxGeneratingTestCase debug: #testSixxStringForRectangle"
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Rectangle" >1@1 corner: 3@4</sixx.object>
'.
	self
		should: [(1@1 corner: 3@4) sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'MU 7/22/2002 00:08'!
testSixxStringForRunArray
	| arr expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="RunArray" >
	<sixx.object sixx.id="1" sixx.name="runs" sixx.type="Array" >
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >1</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >2</sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.name="values" sixx.type="Array" >
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >3</sixx.object>
	</sixx.object>
</sixx.object>
'.

	arr := RunArray runs: #(1 2 1) values: #(1 2 3).
	self should: [arr sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 6/25/2004 01:42'!
testSixxStringForSet
	| set result |
	set := Set new.
	set add: 10.
	set add: 20.
	set add: 30.
	set add: 30.
	result := Object readSixxFrom: set sixxString.
	self
		should: [result size = 3].
	self
		should: [result includes: 10].
	self
		should: [result includes: 20].
	self
		should: [result includes: 30].
	! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:19'!
testSixxStringForSimpleObject
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Object" >
</sixx.object>
'.
	self
		should: [Object new sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:20'!
testSixxStringForString
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="String" >Hi&#44; I&apos;m String-object</sixx.object>
'.
	self
		should: ['Hi, I''m String-object' sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 12/19/2006 18:40'!
testSixxStringForStringUsingCDATA
	| originalSetting expectedStr |
	[originalSetting := SixxSettings useCDATA.
	SixxSettings useCDATA: true.
	expectedStr := '<sixx.object sixx.id="0" sixx.type="String" ><!![CDATA[Hi, I''m String-object.
How are you?
]]></sixx.object>
'.
	self
		should: ['Hi, I''m String-object.
How are you?
' sixxString = expectedStr]]
		ensure: [SixxSettings useCDATA: originalSetting]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'MU 6/11/2003 17:44'!
testSixxStringForTime
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Time" >' 
				, (Time readFrom: '1:30:59 pm' readStream) sixxContentString , '</sixx.object>
'.
	self 
		should: [(Time readFrom: '1:30:59 pm' readStream) sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 4/11/2007 10:57'!
testSixxStringForUndefinedObject
	| expectedStr |
	expectedStr :=  '<sixx.object sixx.type="UndefinedObject" />
'.
	self
		should: [nil sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 6/25/2004 04:37'!
testSixxStringForVariableObject
	| expectedStr variableObj |
	expectedStr :='<sixx.object sixx.id="0" sixx.type="SixxMockBinaryData" >
	<sixx.object sixx.id="1" sixx.name="author" sixx.type="String" >MU</sixx.object>
	<sixx.object sixx.id="2" sixx.name="version" sixx.type="String" >0.1</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >1</sixx.object>
	<sixx.object sixx.id="4" sixx.type="SmallInteger" >2</sixx.object>
	<sixx.object sixx.id="5" sixx.type="SmallInteger" >3</sixx.object>
</sixx.object>
'.
	
	variableObj := SixxMockBinaryData author: 'MU' version: '0.1' data: #(1 2 3).
	self
		should: [variableObj sixxString = expectedStr].
	
	! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'MU 10/27/2002 18:34'!
testSixxStringForVariableObjectNoData
	| expectedStr variableObj |
	
	expectedStr := '<sixx.object sixx.id="0" sixx.type="SixxMockBinaryData" >
	<sixx.object sixx.id="1" sixx.name="author" sixx.type="String" >MU</sixx.object>
	<sixx.object sixx.id="2" sixx.name="version" sixx.type="String" >0.1</sixx.object>
</sixx.object>
'.

	variableObj := SixxMockBinaryData author: 'MU' version: '0.1' data: #().
	self
		should: [variableObj sixxString = expectedStr].
! !

SixxAbstractTestCase subclass: #SixxLoadingTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 4/2/2007 23:48'!
testReadCompactSixxForRecursiveArray

	"SixxLoadingTestCase debug: #testReadCompactSixxForRecursiveArray"
	
	| originalSettings sixxString arr  |
	originalSettings := SixxSettings useCompactTags.
	[SixxSettings useCompactTags: true.
	
	sixxString := '<o i="0" t="Array" >
	<o i="1" t="SmallInteger" >10</o>
	<o i="2" t="SmallInteger" >20</o>
	<o r="0" ></o>
</o>
'.
	arr := Object readSixxFrom: sixxString.
	self
		should: [arr size = 3].
	self
		should: [(arr at: 1)
				= 10].
	self
		should: [(arr at: 2)
				= 20].
	self
		should: [(arr at: 3)
				== arr]
			
	] ensure: [SixxSettings useCompactTags: originalSettings].! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 4/2/2007 23:50'!
testReadCompactSixxForRecursiveDictionary

	"SixxLoadingTestCase debug: #testReadCompactSixxForRecursiveDictionary"

	| originalSettings sixxString dic |
	originalSettings := SixxSettings useCompactTags.
	[SixxSettings useCompactTags: true.

	sixxString := '<o i="0" t="Dictionary" >
	<o i="1" t="Association" >
		<o i="2" n="key" t="Symbol" >key2</o>
		<o i="3" n="value" t="SmallInteger" >100</o>
	</o>
	<o i="4" t="Association" >
		<o i="5" n="key" t="Symbol" >key1</o>
		<o i="6" n="value" t="String" >value1</o>
	</o>
	<o i="7" t="Association" >
		<o i="8" n="key" t="Symbol" >key3</o>
		<o r="0" n="value" ></o>
	</o>
</o>
'.
	dic := Object readSixxFrom: sixxString.
	self
		should: [dic size = 3].
	self
		should: [(dic at: #key1)
				= 'value1'].
	self
		should: [(dic at: #key2)
				= 100].
	self
		should: [(dic at: #key3)
				== dic]
			
	] ensure: [SixxSettings useCompactTags: originalSettings].! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:23'!
testReadSixxForArray
	| sixxString arr |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	arr := Object readSixxFrom: sixxString.
	self
		should: [arr size = 3].
	self
		should: [(arr at: 1)
				= 10].
	self
		should: [(arr at: 2)
				= 20].
	self
		should: [(arr at: 3)
				= 30]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:23'!
testReadSixxForBag
	| sixxString bag |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Bag" >
	<sixx.object sixx.id="1" sixx.type="String" >abcd</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.idref="2" ></sixx.object>
	<sixx.object sixx.id="3" sixx.type="Array" >
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.id="4" sixx.type="SmallInteger" >20</sixx.object>
	</sixx.object>
</sixx.object>
'.
	bag := Object readSixxFrom: sixxString.
	self
		should: [bag size = 4].
	self
		should: [(bag occurrencesOf: 10)
				= 2].
	self
		should: [(bag occurrencesOf: 'abcd')
				= 1].
	self
		should: [(bag occurrencesOf: #(10 20 ))
				= 1]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:25'!
testReadSixxForBoolean
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="True" >true</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= true]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 6/26/2004 12:18'!
testReadSixxForByteArray
	| sixxString byteArr |
	sixxString := '<sixx.object sixx.id="0" sixx.type="ByteArray" >0A141E</sixx.object>
'.
	byteArr := Object readSixxFrom: sixxString.
	self
		should: [byteArr size = 3].
	self
		should: [(byteArr at: 1)
				= 10].
	self
		should: [(byteArr at: 2)
				= 20].
	self
		should: [(byteArr at: 3)
				= 30]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:29'!
testReadSixxForCharacter
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Character" >$A</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= $A]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:31'!
testReadSixxForClass
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockClassForUnitTest class" >
	<sixx.object sixx.id="1" sixx.name="instVar1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.name="instVar2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.name="instVar3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	SixxMockClassForUnitTest instVar1: 0;
		 instVar2: 0;
		 instVar3: 0.
	self
		should: [SixxMockClassForUnitTest instVar1 = 0].
	self
		should: [SixxMockClassForUnitTest instVar2 = 0].
	self
		should: [SixxMockClassForUnitTest instVar3 = 0].
	Object readSixxFrom: sixxString.
	self
		should: [SixxMockClassForUnitTest instVar1 = 10].
	self
		should: [SixxMockClassForUnitTest instVar2 = 20].
	self
		should: [SixxMockClassForUnitTest instVar3 = 30]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:32'!
testReadSixxForColor
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Color" >(Color r: 0.0 g: 0.0 b: 1.0)</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= Color blue]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:33'!
testReadSixxForCompositeObject
	| sixxString slipObj headerObj |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockEnvelope" >
	<sixx.object sixx.id="1" sixx.name="header" sixx.type="SixxMockHeader" >
		<sixx.object sixx.id="2" sixx.name="id" sixx.type="String" >99</sixx.object>
	</sixx.object>
</sixx.object>
'.
	slipObj := Object readSixxFrom: sixxString.
	headerObj := slipObj header.
	self
		should: [headerObj id = '99']! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 12/19/2006 18:41'!
testReadSixxForCorruptRecursiveDictionary
	| originalRecoveryRead |
	[ |  sixxString |
	originalRecoveryRead := SixxSettings useRecoveryRead.
	SixxSettings useRecoveryRead: false.
	sixxString := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object six
'.
	self should:[ Object readSixxFrom: sixxString] raise: SixxXmlParseError.
	
	] ensure: [SixxSettings useRecoveryRead: originalRecoveryRead]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:34'!
testReadSixxForDate
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Date" >14 May 2002</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (Date
						newDay: 14
						month: 5
						year: 2002)]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 7/20/2006 15:59'!
testReadSixxForDateAndTime
	"self debug: #testReadSixxForDateAndTime"
	| sixxString |
	sixxString :=  '<sixx.object sixx.id="0" sixx.type="DateAndTime" >2006-07-19T03:45:06+00:00</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (DateAndTime year: 2006 day: 200 hour: 3 minute: 45 second: 6)]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 12/12/2006 19:22'!
testReadSixxForDateAndTimeOldFormat
	"self debug: #testReadSixxForDateAndTimeOldFormat"
	| sixxString |
	sixxString :=   '<sixx.object sixx.id="0" sixx.type="DateAndTime" sixx.env="Smalltalk" >
	<sixx.object sixx.id="1" sixx.name="seconds" sixx.type="SmallInteger" sixx.env="Smalltalk" >68952</sixx.object>
	<sixx.object sixx.id="2" sixx.name="offset" sixx.type="Duration" sixx.env="Smalltalk" >
		<sixx.object sixx.id="3" sixx.name="nanos" sixx.type="SmallInteger" sixx.env="Smalltalk" >0</sixx.object>
		<sixx.object sixx.idref="3" sixx.name="seconds" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.name="jdn" sixx.type="SmallInteger" sixx.env="Smalltalk" >2454082</sixx.object>
	<sixx.object sixx.idref="3" sixx.name="nanos" ></sixx.object>
</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (DateAndTime year: 2006 day: 346 hour: 19 minute: 9 second: 12)]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:35'!
testReadSixxForDictionary
	| sixxString dic |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
</sixx.object>
'.
	dic := Object readSixxFrom: sixxString.
	self
		should: [dic size = 2].
	self
		should: [(dic at: #key1)
				= 'value1'].
	self
		should: [(dic at: #key2)
				= 100]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 5/4/2007 13:19'!
testReadSixxForFraction
	"SixxLoadingTestCase debug: #testReadSixxForFraction"
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Fraction" >(3/4)</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (3/4)]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'minami 3/18/2003 01:36'!
testReadSixxForInterval
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Interval" >(1 to: 10 by: 3)</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (1 to: 10 by: 3)]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 6/24/2007 17:34'!
testReadSixxForObjectWithId
	"SixxLoadingTestCase debug: #testReadSixxForObjectWithId"
	| sixxString array |
	sixxString :=  '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="a" sixx.type="SixxMockObjectWithId" >
		<sixx.object sixx.id="2" sixx.name="id" sixx.type="String" >a</sixx.object>
		<sixx.object sixx.id="3" sixx.name="data" sixx.type="String" >aaa</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="b" sixx.type="SixxMockObjectWithId" >
		<sixx.object sixx.id="5" sixx.name="id" sixx.type="String" >b</sixx.object>
		<sixx.object sixx.id="6" sixx.name="data" sixx.type="String" >bbb</sixx.object>
	</sixx.object>
	<sixx.object sixx.idref="a" ></sixx.object>
</sixx.object>
'.
	array := Object readSixxFrom: sixxString.

	self should: [(array at: 1) = (array at: 3)].
	self shouldnt: [(array at: 1) = (array at: 2)].

	self should: [(array at: 1) id = 'a'].
	self should: [(array at: 1) data = 'aaa'].
	self should: [(array at: 2) id = 'b'].
	self should: [(array at: 2) data = 'bbb'].! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 6/25/2004 20:34'!
testReadSixxForPoint
	| sixxString |
	sixxString :=  '<sixx.object sixx.id="0" sixx.type="Point" >1@3</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (1@3)].
			
	sixxString :=  '<sixx.object sixx.id="0" sixx.type="Point" >123456789.0@-3.5</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (123456789.0@-3.5)].
			
		! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 12/12/2006 19:50'!
testReadSixxForRectangle
	"SixxLoadingTestCase debug: #testReadSixxForRectangle"
	| sixxString |
	sixxString :=  '<sixx.object sixx.id="0" sixx.type="Rectangle" >1@1 corner: 3@4</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (1@1 corner: 3@4)].
			
	sixxString :=   '<sixx.object sixx.id="0" sixx.type="Rectangle" >-1@1.234 corner: 3.456@5</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (-1@1.234 corner: 3.456@5)].
			
		! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 12/12/2006 19:51'!
testReadSixxForRectangleOldFormat
	"SixxLoadingTestCase debug: #testReadSixxForRectangleOldFormat"
	| sixxString |
	sixxString :=  '<sixx.object sixx.id="0" sixx.type="Rectangle" >
	<sixx.object sixx.id="1" sixx.name="origin" sixx.type="Point" >1@1</sixx.object>
	<sixx.object sixx.id="2" sixx.name="corner" sixx.type="Point" >3@4</sixx.object>
</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (1@1 corner: 3@4)].
			
	! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:37'!
testReadSixxForRecursiveArray
	| sixxString arr |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.idref="0" ></sixx.object>
</sixx.object>
'.
	arr := Object readSixxFrom: sixxString.
	self
		should: [arr size = 3].
	self
		should: [(arr at: 1)
				= 10].
	self
		should: [(arr at: 2)
				= 20].
	self
		should: [(arr at: 3)
				== arr]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:38'!
testReadSixxForRecursiveDictionary
	| sixxString dic |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object sixx.id="8" sixx.name="key" sixx.type="Symbol" >key3</sixx.object>
		<sixx.object sixx.idref="0" sixx.name="value" ></sixx.object>
	</sixx.object>
</sixx.object>
'.
	dic := Object readSixxFrom: sixxString.
	self
		should: [dic size = 3].
	self
		should: [(dic at: #key1)
				= 'value1'].
	self
		should: [(dic at: #key2)
				= 100].
	self
		should: [(dic at: #key3)
				== dic]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'MU 7/22/2002 00:06'!
testReadSixxForRunArray
	| sixxString runArray |
	sixxString := '<sixx.object sixx.id="0" sixx.type="RunArray" >
	<sixx.object sixx.id="1" sixx.name="runs" sixx.type="Array" >
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >1</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >2</sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.name="values" sixx.type="Array" >
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >3</sixx.object>
	</sixx.object>
</sixx.object>
'.
	runArray := Object readSixxFrom: sixxString.

	self should: [runArray runs = #(1 2 1)].
	self should: [runArray values = #(1 2 3)]
	! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:39'!
testReadSixxForSimpleObject
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockHeader" >
	<sixx.object sixx.id="1" sixx.name="id" sixx.type="String" >1000</sixx.object>
</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString) id = '1000']! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 12/19/2006 18:41'!
testReadSixxForStringUsingCDATA
	| originalSetting sixxString string |
	[originalSetting := SixxSettings useCDATA.
	SixxSettings useCDATA: true.
	sixxString := '<sixx.object sixx.id="0" sixx.type="String" ><!![CDATA[Hi, I''m String-object.
How are you?
]]></sixx.object>
'.
	string := Object readSixxFrom: sixxString.
	self
		should: [string = 'Hi, I''m String-object.
How are you?
']]
		ensure: [SixxSettings useCDATA: originalSetting]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:39'!
testReadSixxForTime
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Time" >4:10:32 pm</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (Time
						readFrom: (ReadStream on: '4:10:32 pm'))]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:43'!
testReadSixxForUndefinedObject
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="UndefinedObject" >nil</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= nil]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 6/25/2004 02:12'!
testReadSixxForVariableObject
	| sixxString variableObj |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockBinaryData" >
	<sixx.object sixx.id="1" sixx.name="author" sixx.type="String" >MU</sixx.object>
	<sixx.object sixx.id="2" sixx.name="version" sixx.type="String" >0.1</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >1</sixx.object>
	<sixx.object sixx.id="4" sixx.type="SmallInteger" >2</sixx.object>
	<sixx.object sixx.id="5" sixx.type="SmallInteger" >3</sixx.object>
</sixx.object>
'.
	
	variableObj := Object readSixxFrom: sixxString.
	self should: [ variableObj author = 'MU'].
	self should: [ variableObj version = '0.1'].
	self should: [ variableObj size = 3].
	self should: [ (variableObj at: 1) = 1].
	self should: [ (variableObj at: 2) = 2].
	self should: [ (variableObj at: 3) = 3].
	
	! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'MU 10/27/2002 18:32'!
testReadSixxForVariableObjectNoData
	
	| sixxString variableObj |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockBinaryData" >
	<sixx.object sixx.id="1" sixx.name="author" sixx.type="String" >MU</sixx.object>
	<sixx.object sixx.id="2" sixx.name="version" sixx.type="String" >0.1</sixx.object>
</sixx.object>
'.
	variableObj := Object readSixxFrom: sixxString.
	self should: [ variableObj author = 'MU'].
	self should: [ variableObj version = '0.1'].
	self should: [ variableObj size = 0].

	
	! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:43'!
testReadSixxWithClassDoesNotExist
	| str catched |
	str := '<sixx.object sixx.id="0" sixx.type="doesNotExistString" >abcde</sixx.object>
'.
	self
		should: [(Object readSixxFrom: str)
				= nil].
	catched := false.
	self
		should: [[Object readSixxFrom: str]
				on: SixxClassNotFound
				do: [:ex | catched := true].
			catched]! !

SixxAbstractTestCase subclass: #SixxNamespaceSupportTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxNamespaceSupportTestCase methodsFor: 'running' stamp: 'mu 12/19/2006 18:41'!
setUp
	originalUseEnvironment := SixxSettings useEnvironment.
	SixxSettings useEnvironment: true! !

!SixxNamespaceSupportTestCase methodsFor: 'running' stamp: 'mu 12/19/2006 18:41'!
tearDown
	SixxSettings useEnvironment: originalUseEnvironment! !

!SixxNamespaceSupportTestCase methodsFor: 'tests' stamp: 'MU 3/25/2003 02:36'!
testNamespacedArray
	"self debug: #testNamespacedArray"
	| arraySixx1 array1  arraySixx2 array2  |
	arraySixx1 :=  '<sixx.object sixx.id="0" sixx.type="Array" sixx.env="Core" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" sixx.env="Core" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" sixx.env="Core" >20</sixx.object>
</sixx.object>
'.
	array1 := Object readSixxFrom: arraySixx1.
	self should: [array1 = #(10 20)].
	
	arraySixx2 := array1 sixxString. 
	array2 := Object readSixxFrom: arraySixx2.
	self should: [array2 = #(10 20)]! !

SixxAbstractTestCase subclass: #SixxNewFailedTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxNewFailedTestCase methodsFor: 'tests' stamp: 'mu 6/24/2004 22:54'!
testWriteReadNewFailedClass
	| original sixxString read |
	original := SixxMockFixedNewFailedClass prototype1.
	self should: [original att1 = 1].
	self should: [original att2 =  'TWO']. 
	self should: [original sixxString] raise: SixxInvalidSerialization.
	sixxString := original sixxString.
	
	self should: [Object readSixxFrom: sixxString] raise: SixxNewFailed.
	read := Object readSixxFrom: sixxString.
	self should: [read att1 = 1].
	self should: [read att2 =  'TWO'].
	self should: [read att3Block notNil].
	
	
	
	! !

!SixxNewFailedTestCase methodsFor: 'tests' stamp: 'mu 6/24/2004 23:04'!
testWriteReadNewFailedClassReciverAlternative
	| original sixxString read |
	original := SixxMockFixedNewFailedClass prototype1.
	self should: [original att1 = 1].
	self should: [original att2 =  'TWO']. 
	self should: [original sixxString] raise: SixxInvalidSerialization.
	sixxString := original sixxString.
	
	self should: [Object readSixxFrom: sixxString] raise: SixxNewFailed.
	read := [Object readSixxFrom: sixxString] on: SixxNewFailed do: [:ex | ex resume: SixxMockFixedAlternativeClass].
	self should: [read class = SixxMockFixedAlternativeClass].
	self should: [read att1 = 1].
	self should: [read att2 =  'TWO'].
	self should: [read att3Block notNil].
	
	
	
	! !

!SixxNewFailedTestCase methodsFor: 'tests' stamp: 'mu 6/24/2004 23:10'!
testWriteReadNewVariableFailedClass
	| original sixxString read |
	original := SixxMockVariableNewFailedClass prototype1.
	self should: [original att1 = 1].
	self should: [original att2 =  'TWO']. 
	self should: [original sixxString] raise: SixxInvalidSerialization.
	sixxString := original sixxString.
	
	self should: [Object readSixxFrom: sixxString] raise: SixxNewFailed.
	read := Object readSixxFrom: sixxString.
	self should: [read att1 = 1].
	self should: [read att2 =  'TWO'].
	self should: [read att3Block notNil].
	
	
	
	! !

!SixxNewFailedTestCase methodsFor: 'tests' stamp: 'mu 6/25/2004 00:59'!
testWriteReadNewVariableFailedClassReciverAlternative
	| original sixxString read |
	original := SixxMockVariableNewFailedClass prototype1.
	self should: [original att1 = 1].
	self should: [original att2 =  'TWO']. 
	self should: [original sixxString] raise: SixxInvalidSerialization.
	sixxString := original sixxString.
	
	self should: [Object readSixxFrom: sixxString] raise: SixxNewFailed.
	read := [Object readSixxFrom: sixxString] on: SixxNewFailed do: [:ex | ex resume: SixxMockVariableAlternativeClass].
	self should: [read class = SixxMockVariableAlternativeClass].
	self should: [read att1 = 1].
	self should: [read att2 =  'TWO'].
	self should: [read att3Block notNil].
	
	
	
	! !

SixxAbstractTestCase subclass: #SixxReadStreamTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:46'!
testAtEnd
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream next = 'a'
				and: [stream atEnd not]].
	self
		should: [stream next = 'b'
				and: [stream atEnd not]].
	self
		should: [stream next = 'c'
				and: [stream atEnd]].
	self
		should: [stream next = nil
				and: [stream atEnd]]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:46'!
testCachedObjects
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	stream next; next.
	self
		should: [(stream cachedObjects at: 1)
				= 'a'].
	self
		should: [(stream cachedObjects at: 2)
				= 'b'].
	self
		shouldnt: [stream cachedObjects includesKey: 3].
	stream next.
	self
		should: [(stream cachedObjects at: 3)
				= 'c']! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'mu 4/2/2007 23:54'!
testCompactNext

	"SixxReadStreamTestCase debug: #testCompactNext"

	| originalSettings str stream |
	originalSettings := SixxSettings useCompactTags.
	[str := '<?xml version="1.0" encoding="utf-8"?>
<cixx v="1.0">
	<o i="0" t="String" >a</o>
	<o i="1" t="String" >b</o>
	<o i="2" t="String" >c</o>
</cixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream next = 'a'].
	self
		should: [stream next = 'b'].
	self
		should: [stream next = 'c'].
	self
		should: [stream next = nil]
		
	] ensure: [SixxSettings useCompactTags: originalSettings]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'mu 4/2/2007 23:56'!
testCompactNextWithIdref

	"SixxReadStreamTestCase debug: #testCompactNextWithIdref"

	| originalSettings str stream |
	originalSettings := SixxSettings useCompactTags.
	[str := '<?xml version="1.0" encoding="utf-8"?>
<cixx v="1.0">
	<o i="0" t="Character" >$a</o>
	<o i="1" t="Character" >$u</o>
	<o r="0" ></o>
	<o r="1" ></o>
</cixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream next = $a].
	self
		should: [stream next = $u].
	self
		should: [stream next = $a].
	self
		should: [stream next = $u]
		
	] ensure: [SixxSettings useCompactTags: originalSettings]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'mu 4/3/2007 00:00'!
testCompactRecoveryRead

	"SixxReadStreamTestCase debug: #testCompactRecoveryRead"

	| originalRecoveryRead originalUseCompactTags  |
	[ |  str stream nextObject |
	originalRecoveryRead := SixxSettings useRecoveryRead.
	originalUseCompactTags := SixxSettings useCompactTags.
	SixxSettings useRecoveryRead: true.
	SixxSettings useCompactTags: true.
	str := '<?xml version="1.0" encoding="utf-8"?>
<cixx v="1.0">
	<o i="0" t="Dictionary" >
	<o i="1" t="Association" >
		<o i="2" n="key" t="Symbol" >key2</o>
		<o i="3" n="value" t="SmallInteger" >100</o>
	</o>
	<o i="4" t="Association" >
		<o i="5" n="key" t="Symbol" >key1</o>
		<o i="6" n="value" t="String" >value1</o>
	</o>
	<o i="7" t="Association" >
		<o i
'.
	stream := SixxReadStream on: str readStream.
	self shouldnt: [nextObject := stream next] raise: SixxXmlParseError.
	self
		should: [nextObject class = Dictionary].
	self
		should: [(nextObject at: #key1)
				= 'value1'].
	self
		should: [(nextObject at: #key2)
				= 100].
	self
		shouldnt: [(nextObject includesKey: #key3)].
	
	] ensure: [SixxSettings useRecoveryRead: originalRecoveryRead; useCompactTags: originalUseCompactTags]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:46'!
testNext
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream next = 'a'].
	self
		should: [stream next = 'b'].
	self
		should: [stream next = 'c'].
	self
		should: [stream next = nil]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:47'!
testNextMany
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [(stream next: 2)
				= (OrderedCollection with: 'a' with: 'b')].
	stream reset.
	self
		should: [(stream next: 5)
				= (OrderedCollection
						with: 'a'
						with: 'b'
						with: 'c')]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'mu 4/2/2007 23:55'!
testNextWithIdref
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Character" >$a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="Character" >$u</sixx.object>
	<sixx.object sixx.idref="0" ></sixx.object>
	<sixx.object sixx.idref="1" ></sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream next = $a].
	self
		should: [stream next = $u].
	self
		should: [stream next = $a].
	self
		should: [stream next = $u]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:48'!
testPeek
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream position = 0].
	self
		should: [stream peek = 'a'].
	self
		should: [stream position = 0].
	self
		should: [stream next = 'a']! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:49'!
testPosition
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	stream next: 3.
	self
		should: [stream position = 3].
	stream position: 1.
	self
		should: [stream next = 'b']! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'MU 2/28/2003 23:35'!
testReadEmptyStream
	| stream empStream |
	empStream := '' readStream.
	self
		should: [empStream size = 0].
	stream :=  SixxReadStream on: empStream.
	
	self
		should: [stream position = 0].
	self
		should: [stream atEnd].
	self
		should: [stream next isNil].
	! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 16:34'!
testReadNextContainsIdref
	| str stream firstObj secondObj thirdObj |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Array" >
		<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="OrderedCollection" >
		<sixx.object sixx.idref="0" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="5" sixx.type="Array" >
		<sixx.object sixx.idref="1" ></sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
	</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream size = 3].
	firstObj := stream next.
	secondObj := stream next.
	thirdObj := stream next.
	self
		should: [firstObj = #(10 20 30 )].
	self
		should: [(secondObj at: 1)
				== firstObj].
	self
		should: [thirdObj = #(10 20 30 )
				and: [thirdObj ~~ firstObj]]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'mu 12/19/2006 18:41'!
testRecoveryRead
	| originalRecoveryRead   |
	[ |  str stream nextObject |
	originalRecoveryRead := SixxSettings useRecoveryRead.
	SixxSettings useRecoveryRead: true.
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object six
'.
	stream := SixxReadStream on: str readStream.
	self shouldnt: [nextObject := stream next] raise: SixxXmlParseError.
	self
		should: [nextObject class = Dictionary].
	self
		should: [(nextObject at: #key1)
				= 'value1'].
	self
		should: [(nextObject at: #key2)
				= 100].
	self
		shouldnt: [(nextObject includesKey: #key3)].
	
	] ensure: [SixxSettings useRecoveryRead: originalRecoveryRead]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:51'!
testReset
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	[stream atEnd]
		whileFalse: [stream next].
	self
		should: [stream next = nil].
	stream reset.
	self
		should: [stream position = 0]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:51'!
testSize
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream size = 3]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:51'!
testSkip
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream position = 0].
	stream skip: 1.
	self
		should: [stream position = 1].
	stream next.
	self
		should: [stream position = 2].
	stream skip: 1.
	self
		should: [stream position = 3].
	stream skip: -1.
	self
		should: [stream position = 2].
	stream skip: 2.
	self
		should: [stream position = 3]! !

SixxAbstractTestCase subclass: #SixxShapeChangeReadStreamTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxShapeChangeReadStreamTestCase methodsFor: 'private' stamp: 'mu 12/25/2006 16:34'!
sixxFrom: object 
	| srs conts |
	srs := SixxWriteStream on: (WriteStream on: (String new: 16)).
	srs nextPut: object.
	conts := srs contents.
	srs close.
	^ conts! !

!SixxShapeChangeReadStreamTestCase methodsFor: 'tests' stamp: 'mu 12/22/2006 16:14'!
testNewFailedRead
	"SixxShapeChangeReadStreamTestCase debug: #testNewFailedRead"
	| oldSixx srs arr obj1 obj2 obj3 |
	oldSixx :=  '<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Array" >
		<sixx.object sixx.id="1" sixx.type="SixxMockFixedNewFailedClass" >
			<sixx.object sixx.id="2" sixx.name="att1" sixx.type="SmallInteger" >1</sixx.object>
			<sixx.object sixx.id="3" sixx.name="att2" sixx.type="SmallInteger" >2</sixx.object>
		</sixx.object>
		<sixx.object sixx.id="5" sixx.type="SixxMockFixedNewFailedClass" >
			<sixx.object sixx.id="6" sixx.name="att1" sixx.type="SmallInteger" >3</sixx.object>
			<sixx.object sixx.id="7" sixx.name="att2" sixx.type="SmallInteger" >4</sixx.object>
		</sixx.object>
		<sixx.object sixx.idref="1" ></sixx.object>
	</sixx.object>
</sixx>'.
	srs := SixxShapeChangeReadStream on: oldSixx readStream.
	srs shapeChangers at: #SixxMockFixedNewFailedClass put: SixxMockFixedAlternativeClass.
	arr := srs next.
	srs close.
	self should: [arr class = Array].
	self should: [arr size = 3].
	obj1 := arr at: 1.
	self should: [obj1 class = SixxMockFixedAlternativeClass].
	self should: [obj1 att1 = 1].
	self should: [obj1 att2 = 2].
	self should: [obj1 att3Block notNil].
	obj2 := arr at: 2.
	self should: [obj2 class = SixxMockFixedAlternativeClass].
	self should: [obj2 att1 = 3].
	self should: [obj2 att2 = 4].
	self should: [obj2 att3Block notNil].
	obj3 := arr at: 3.
	self should: [obj3 = obj1].! !

!SixxShapeChangeReadStreamTestCase methodsFor: 'tests' stamp: 'mu 12/25/2006 16:34'!
testRenamedRead
	"SixxShapeChangeReadStreamTestCase debug: #testRenamedRead"
	| data oldSixx srs obj |
	data := Array with: 1 with:2 with: (Array with:1 with:3 with:1).
	oldSixx := (self sixxFrom: data) copyReplaceAll: 'SmallInteger' with: 'SmallIntegerOLD'.
	srs := SixxShapeChangeReadStream on: oldSixx readStream.
	srs shapeChangers at: #SmallIntegerOLD put: SmallInteger.
	obj := srs next.
	srs close.
	self should: [obj = data]! !

!SixxShapeChangeReadStreamTestCase methodsFor: 'tests' stamp: 'mu 12/25/2006 16:34'!
testRenamedReadFailed
	"SixxShapeChangeReadStreamTestCase debug: #testRenamedReadFailed"
	| data oldSixx srs obj |
	data := Array with: 1 with:2 with: (Array with:1 with:3 with:1).
	oldSixx := (self sixxFrom: data) copyReplaceAll: 'SmallInteger' with: 'SmallIntegerOLD'.
	srs := SixxShapeChangeReadStream on: oldSixx readStream.
	obj := srs next.
	srs close.
	self shouldnt: [obj = data].
	self should: [obj = #(nil nil #(nil nil nil))]! !

!SixxShapeChangeReadStreamTestCase methodsFor: 'tests' stamp: 'mu 12/22/2006 15:46'!
testShapeChangedComplexRead
	"SixxShapeChangeReadStreamTestCase debug: #testShapeChangedComplexRead"
	| oldSixx srs arr obj1 obj2 obj3 |
	oldSixx :=  '<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Array" >
		<sixx.object sixx.id="1" sixx.type="SixxMockShapeChangedObjectOLD" >
			<sixx.object sixx.id="2" sixx.name="oldNamedVar1" sixx.type="SmallInteger" >1</sixx.object>
			<sixx.object sixx.id="3" sixx.name="originalAtt1" sixx.type="SmallInteger" >3</sixx.object>
		</sixx.object>
		<sixx.object sixx.id="4" sixx.type="SixxMockShapeChangedObjectOLD" >
			<sixx.object sixx.id="5" sixx.name="oldNamedVar1" sixx.type="SmallInteger" >11</sixx.object>
			<sixx.object sixx.id="6" sixx.name="originalAtt1" sixx.type="SmallInteger" >33</sixx.object>
		</sixx.object>
		<sixx.object sixx.idref="1" ></sixx.object>
	</sixx.object>
</sixx>'.
	srs := SixxShapeChangeReadStream on: oldSixx readStream.
	srs shapeChangers at: #SixxMockShapeChangedObjectOLD put: SixxMockShapeChangedObject.
	arr := srs next.
	srs close.
	self should: [arr class = Array].
	self should: [arr size = 3].
	obj1 := arr at: 1.
	self should: [obj1 renamedAtt1 = 1].
	self should: [obj1 addedAtt1 = 2].
	self should: [obj1 originalAtt1 = 3].
	obj2 := arr at: 2.
	self should: [obj2 renamedAtt1 = 11].
	self should: [obj2 addedAtt1 = 2].
	self should: [obj2 originalAtt1 = 33].
	obj3 := arr at: 3.
	self should: [obj3 = obj1].! !

!SixxShapeChangeReadStreamTestCase methodsFor: 'tests' stamp: 'mu 12/22/2006 16:02'!
testShapeChangedComplexReadFailed
	"SixxShapeChangeReadStreamTestCase debug: #testShapeChangedComplexReadFailed"
	| oldSixx srs arr |
	oldSixx :=  '<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Array" >
		<sixx.object sixx.id="1" sixx.type="SixxMockShapeChangedObjectOLD" >
			<sixx.object sixx.id="2" sixx.name="oldNamedVar1" sixx.type="SmallInteger" >1</sixx.object>
			<sixx.object sixx.id="3" sixx.name="originalAtt1" sixx.type="SmallInteger" >3</sixx.object>
		</sixx.object>
		<sixx.object sixx.id="4" sixx.type="SixxMockShapeChangedObjectOLD" >
			<sixx.object sixx.id="5" sixx.name="oldNamedVar1" sixx.type="SmallInteger" >11</sixx.object>
			<sixx.object sixx.id="6" sixx.name="originalAtt1" sixx.type="SmallInteger" >33</sixx.object>
		</sixx.object>
		<sixx.object sixx.idref="1" ></sixx.object>
		<sixx.object sixx.id="0" sixx.type="String" >here</sixx.object>
	</sixx.object>
</sixx>'.
	srs := SixxShapeChangeReadStream on: oldSixx readStream.
	srs shapeChangers at: #SixxMockShapeChangedObjectFAILED put: SixxMockShapeChangedObject.
	arr := srs next.
	srs close.
	self should: [arr class = Array].
	self should: [arr = #(nil nil nil 'here')].
	! !

!SixxShapeChangeReadStreamTestCase methodsFor: 'tests' stamp: 'mu 6/5/2007 20:08'!
testShapeChangedConverterRead
	"SixxShapeChangeReadStreamTestCase debug: #testShapeChangedConverterRead"
	| oldSixx srs arr obj1 obj2 obj3 |
	oldSixx :=  '<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Array" >
		<sixx.object sixx.id="1" sixx.type="SixxMockShapeChangedObjectOLD" >
			<sixx.object sixx.id="2" sixx.name="oldNamedVar1" sixx.type="SmallInteger" >1</sixx.object>
			<sixx.object sixx.id="3" sixx.name="originalAtt1" sixx.type="SmallInteger" >3</sixx.object>
		</sixx.object>
		<sixx.object sixx.id="4" sixx.type="SixxMockShapeChangedObjectOLD" >
			<sixx.object sixx.id="5" sixx.name="oldNamedVar1" sixx.type="SmallInteger" >11</sixx.object>
			<sixx.object sixx.id="6" sixx.name="originalAtt1" sixx.type="SmallInteger" >33</sixx.object>
			<sixx.object sixx.id="7" sixx.name="oldVar2" sixx.type="SmallInteger" >44</sixx.object>
		</sixx.object>
		<sixx.object sixx.idref="1" ></sixx.object>
	</sixx.object>
</sixx>'.
	srs := SixxShapeChangeReadStream on: oldSixx readStream.
	srs shapeChangers at: #SixxMockShapeChangedObjectOLD put: SixxMockShapeChanger.
	arr := srs next.
	srs close.
	self should: [arr class = Array].
	self should: [arr size = 3].
	obj1 := arr at: 1.
	self should: [obj1 renamedAtt1 = 1].
	self should: [obj1 addedAtt1 = 22222].
	self should: [obj1 originalAtt1 = 3].
	obj2 := arr at: 2.
	self should: [obj2 renamedAtt1 = 11].
	self should: [obj2 addedAtt1 = 22222].
	self should: [obj2 originalAtt1 = 33].
	obj3 := arr at: 3.
	self should: [obj3 = obj1].! !

!SixxShapeChangeReadStreamTestCase methodsFor: 'tests' stamp: 'mu 6/5/2007 22:24'!
testShapeChangedConverterReadWithSameClassName
	"SixxShapeChangeReadStreamTestCase debug: #testShapeChangedConverterReadWithSameClassName"
	| oldSixx srs arr obj1 obj2 obj3 |
	oldSixx :=  '<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Array" >
		<sixx.object sixx.id="1" sixx.type="SixxMockShapeChangedObjectWithoutShapeChangeMethods" >
			<sixx.object sixx.id="2" sixx.name="oldNamedVar1" sixx.type="SmallInteger" >1</sixx.object>
			<sixx.object sixx.id="3" sixx.name="originalAtt1" sixx.type="SmallInteger" >3</sixx.object>
		</sixx.object>
		<sixx.object sixx.id="4" sixx.type="SixxMockShapeChangedObjectWithoutShapeChangeMethods" >
			<sixx.object sixx.id="5" sixx.name="oldNamedVar1" sixx.type="SmallInteger" >11</sixx.object>
			<sixx.object sixx.id="6" sixx.name="originalAtt1" sixx.type="SmallInteger" >33</sixx.object>
			<sixx.object sixx.id="7" sixx.name="oldVar2" sixx.type="SmallInteger" >44</sixx.object>
		</sixx.object>
		<sixx.object sixx.idref="1" ></sixx.object>
	</sixx.object>
</sixx>'.
	srs := SixxShapeChangeReadStream on: oldSixx readStream.
	srs shapeChangers at: #SixxMockShapeChangedObjectWithoutShapeChangeMethods put: SixxMockShapeChanger.
	arr := srs next.
	srs close.
	self should: [arr class = Array].
	self should: [arr size = 3].
	obj1 := arr at: 1.
	self should: [obj1 renamedAtt1 = 1].
	self should: [obj1 addedAtt1 = 22222].
	self should: [obj1 originalAtt1 = 3].
	obj2 := arr at: 2.
	self should: [obj2 renamedAtt1 = 11].
	self should: [obj2 addedAtt1 = 22222].
	self should: [obj2 originalAtt1 = 33].
	obj3 := arr at: 3.
	self should: [obj3 = obj1].! !

!SixxShapeChangeReadStreamTestCase methodsFor: 'tests' stamp: 'mu 12/22/2006 15:42'!
testShapeChangedRead
	"SixxShapeChangeReadStreamTestCase debug: #testShapeChangedRead"
	| oldSixx srs obj |
	oldSixx :=  '<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="SixxMockShapeChangedObjectOLD" >
		<sixx.object sixx.id="1" sixx.name="oldNamedVar1" sixx.type="SmallInteger" >1</sixx.object>
		<sixx.object sixx.id="3" sixx.name="originalAtt1" sixx.type="SmallInteger" >3</sixx.object>
	</sixx.object>
</sixx>'.
	srs := SixxShapeChangeReadStream on: oldSixx readStream.
	srs shapeChangers at: #SixxMockShapeChangedObjectOLD put: SixxMockShapeChangedObject.
	obj := srs next.
	srs close.
	self should: [obj class = SixxMockShapeChangedObject].
	self should: [obj renamedAtt1 = 1].
	self should: [obj addedAtt1 = 2].
	self should: [obj originalAtt1 = 3].! !

SixxAbstractTestCase subclass: #SixxWriteStreamTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'MU 9/17/2002 01:37'!
testCloseTwice
	| st wst expected |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >abc</sixx.object>
</sixx>'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: 'abc'.
	wst close.
	wst close.
	self
		should: [st contents = expected]! !

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'mu 4/3/2007 00:03'!
testCompactWriteRecursiveObject

	"SixxWriteStreamTestCase debug: #testCompactWriteRecursiveObject"
	
	| originalSettings st wst expected arr col |
	originalSettings := SixxSettings useCompactTags.
	SixxSettings useCompactTags: true.
	[expected := '<?xml version="1.0" encoding="utf-8"?>
<cixx v="1.0">
	<o i="0" t="Array" >
		<o i="1" t="SmallInteger" >10</o>
		<o i="2" t="SmallInteger" >20</o>
		<o i="3" t="SmallInteger" >30</o>
	</o>
	<o i="4" t="OrderedCollection" >
		<o r="0" ></o>
	</o>
	<o i="5" t="Array" >
		<o r="1" ></o>
		<o r="2" ></o>
		<o r="3" ></o>
	</o>
</cixx>'.
	arr := #(10 20 30 ).
	col := OrderedCollection with: arr.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: arr.
	wst nextPut: col.
	wst nextPut: #(10 20 30 ) copy.
	wst close.
	self
		should: [st contents = expected]
		
	] ensure: [SixxSettings useCompactTags: originalSettings]! !

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'MU 9/17/2002 01:37'!
testKeepStreamOpening
	| st wst expected |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >abc</sixx.object>
'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: 'abc'.
	self
		should: [st contents = expected]! !

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'MU 9/17/2002 01:37'!
testNeverNextPutAndThenClose
	| st wst expected |
	expected := ''.
	st := WriteStream on: String new.
	wst := SixxWriteStream on: st.
	wst close.
	self
		should: [st contents = expected]! !

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'MU 9/17/2002 01:37'!
testNextPut
	| st wst expected |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >abc</sixx.object>
</sixx>'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: 'abc'.
	wst close.
	self
		should: [st contents = expected]! !

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'MU 9/17/2002 01:37'!
testNextPutAll
	| st wst expected |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Character" >$a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="Character" >$b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="Character" >$c</sixx.object>
</sixx>'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPutAll: 'abc'.
	wst close.
	self
		should: [st contents = expected]! !

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'MU 9/17/2002 01:38'!
testWriteRecursiveObject
	| st wst expected arr col |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Array" >
		<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="OrderedCollection" >
		<sixx.object sixx.idref="0" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="5" sixx.type="Array" >
		<sixx.object sixx.idref="1" ></sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
	</sixx.object>
</sixx>'.
	arr := #(10 20 30 ).
	col := OrderedCollection with: arr.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: arr.
	wst nextPut: col.
	wst nextPut: #(10 20 30 ) copy.
	wst close.
	self
		should: [st contents = expected]! !

SixxAbstractTestCase subclass: #SixxXmlParserTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxXmlParserTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:59'!
testParseXmlWithSixxVwXmlParserAdapter
	| sixxString result oldParser |
	self class environment
		at: #VWXMLXMLParser
		ifAbsent: [^ self].
	sixxString := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >100</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >abcde</sixx.object>
	<sixx.object sixx.id="3" sixx.type="Array" >
		<sixx.object sixx.id="4" sixx.type="SmallInteger" >10</sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >20</sixx.object>
	</sixx.object>
	<sixx.object sixx.idref="0" ></sixx.object>
</sixx.object>
'.
	oldParser := SixxXmlUtil parserAdapter.
	[SixxXmlUtil parserAdapter: SixxVwXmlParserAdapter.
	result := Object readSixxFrom: sixxString.
	self
		should: [(result at: 1)
				= 100].
	self
		should: [(result at: 2)
				= 'abcde'].
	self
		should: [(result at: 3)
				= #(10 20 )].
	self
		should: [(result at: 4)
				== result]]
		ensure: [SixxXmlUtil parserAdapter: oldParser]! !

!SixxXmlParserTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 15:00'!
testParseXmlWithSixxYaxoXmlParserAdapter
	| sixxString result oldParser |
	self class environment
		at: #XMLDOMParser
		ifAbsent: [^ self].
	sixxString := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >100</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >abcde</sixx.object>
	<sixx.object sixx.id="3" sixx.type="Array" >
		<sixx.object sixx.id="4" sixx.type="SmallInteger" >10</sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >20</sixx.object>
	</sixx.object>
	<sixx.object sixx.idref="0" ></sixx.object>
</sixx.object>
'.
	oldParser := SixxXmlUtil parserAdapter.
	[SixxXmlUtil parserAdapter: SixxYaxoXmlParserAdapter.
	result := Object readSixxFrom: sixxString.
	self
		should: [(result at: 1)
				= 100].
	self
		should: [(result at: 2)
				= 'abcde'].
	self
		should: [(result at: 3)
				= #(10 20 )].
	self
		should: [(result at: 4)
				== result]]
		ensure: [SixxXmlUtil parserAdapter: oldParser]! !

!Dictionary methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:33'!
sixxContentOn: aStream indent: level context: dictionary
	aStream cr.
	self
		associationsDo: [:each | each
				sixxOn: aStream
				indent: level + 1
				context: dictionary].
	aStream tab: level.! !

!ShortIntegerArray class methodsFor: '*sixx-instance creation' stamp: 'mu 6/25/2004 21:07'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| col |
	col := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	^self withAll: col! !

!ShortIntegerArray methodsFor: '*sixx-printing' stamp: 'mu 6/25/2004 21:03'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: '#( '.
	self do:[:each | aStream nextPutAll: each printString; space].
	aStream nextPutAll: ')'.! !

!Point class methodsFor: '*sixx-instance creation' stamp: 'mu 6/25/2004 20:31'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| readStr x y |
	readStr := ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement).
	x _ (readStr upTo: $@) asNumber.
	y _ (readStr upToEnd) asNumber.
	^self x: x y: y! !

!Point methodsFor: '*sixx-printing' stamp: 'mu 6/25/2004 20:23'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: x printString.
	aStream nextPut: $@.
	aStream nextPutAll: y printString.
	
	! !

!Preferences class methodsFor: '*sixx-personalization' stamp: 'mu 6/25/2004 19:41'!
sixxLoadPreferencesFrom: aFileName
	| stream params dict desktopColor |
	stream _ SixxReadStream readOnlyFileNamed: aFileName.
	params _ stream next.
	self assert: (params isKindOf: IdentityDictionary).
	params removeKey: #PersonalDictionaryOfPreferences.
	dict _ stream next.
	self assert: (dict isKindOf: IdentityDictionary).
	desktopColor _ stream next.
	stream close.
	dict keysAndValuesDo:
		[:key :value | (self preferenceAt: key ifAbsent: [nil]) ifNotNilDo:
			[:pref | pref preferenceValue: value preferenceValue]].

	params keysAndValuesDo: [ :key :value | self setParameter: key to: value ].

	Smalltalk isMorphic
		ifTrue: [ World fillStyle: desktopColor ]
		ifFalse: [ self desktopColor: desktopColor. ScheduledControllers updateGray ].
! !

!Preferences class methodsFor: '*sixx-personalization' stamp: 'mu 6/25/2004 19:27'!
sixxStorePreferencesIn: aFileName
	| stream |
	#(Prevailing PersonalPreferences) do: [ :ea | Parameters removeKey: ea ifAbsent: []].  
	stream _ SixxWriteStream newFileNamed: aFileName.
	stream nextPut: Parameters.
	stream nextPut: DictionaryOfPreferences.
	Smalltalk isMorphic
		ifTrue: [ stream nextPut: World fillStyle ]
		ifFalse: [ stream nextPut: DesktopColor ].
	stream close.! !

!Boolean class methodsFor: '*sixx-instance creation' stamp: 'mu 11/8/2006 14:51'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| read |
	read := SixxXmlUtil characterDataFrom: sixxElement.
	^ read = 'true'! !

!Boolean methodsFor: '*sixx-printing' stamp: 'mu 4/5/2007 11:29'!
sixxOn: aStream name: nameString indent: level context: dictionary
	| constants |
	aStream tab: level.
	constants := SixxConstants current.
	aStream nextPutAll: ( SixxXmlUtil contentsWithEmptyTagNamed: constants objectTagName do: [:wStr |   
		SixxXmlUtil writeAttribute: constants nameTagName value: nameString on: wStr.
		SixxXmlUtil writeAttribute: constants typeTagName value: self sixxType on: wStr.
		SixxSettings useEnvironment 
			ifTrue: [SixxXmlUtil writeAttribute: constants envTagName value: self sixxEnv on: wStr.].
	]).
	aStream cr.

	! !

!RunArray class methodsFor: '*sixx-instance creation' stamp: 'MU 7/21/2002 23:30'!
createInstanceOf: aClass withSixxElement: sixxElement
	"squeak specific"
	
	^aClass basicNew! !

!RunArray methodsFor: '*sixx-initializing' stamp: 'MU 7/21/2002 23:35'!
initializeFromSixxElement: sixxElement context: aDictionary 
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | varName | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [varName := self class nameFromSixxElement: elem.
					varName notNil
						ifTrue: [| childInst | 
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst]]]! !

!RunArray methodsFor: '*sixx-printing' stamp: 'MU 7/9/2002 01:25'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream cr.
	self runs
		sixxOn: aStream
		name: 'runs'
		indent: level + 1
		context: dictionary.
	self values
		sixxOn: aStream
		name: 'values'
		indent: level + 1
		context: dictionary.
	aStream tab: level! !

!Symbol class methodsFor: '*sixx-instance creation' stamp: 'mu 5/9/2002 17:46'!
createInstanceOf: aClass withSixxElement: sixxElement
	^(super createInstanceOf: aClass withSixxElement: sixxElement) asSymbol! !

!Symbol methodsFor: '*sixx-private' stamp: 'mu 2/7/2006 21:12'!
sixxType
	^#Symbol! !

!Number class methodsFor: '*sixx-instance creation' stamp: 'kuri-t 5/15/2002 18:06'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ (SixxXmlUtil characterDataFrom: sixxElement) asNumber
	! !

!Number methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:36'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self asString
	! !

!ClassDescription methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:32'!
sixxContentOn: aStream indent: level context: dictionary
	| instVars startIndex  |	
	aStream cr.
	instVars := self class allInstVarNames.
	startIndex := Object class allInstVarNames size + 1.
	startIndex to: instVars size do: [:idx | 
			(self instVarAt: idx)
				sixxOn: aStream
				name: (instVars at: idx)
				indent: level + 1
				context: dictionary].! !

!TTCFont class methodsFor: '*sixx-instance creation' stamp: 'mu 12/12/2006 23:38'!
familyName: aName size: aSize emphasized: emphasisCode
	^self familyName: aName pointSize: aSize emphasis: emphasisCode! !

!Interval class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:22'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!Interval methodsFor: '*sixx-printing' stamp: 'minami 3/18/2003 01:47'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: self printString! !

!FloatArray class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:19'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| col |
	col := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	^ col asFloatArray! !

!FloatArray methodsFor: '*sixx-printing' stamp: 'MU 6/29/2002 16:03'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: '#( '.
	self do:[:each | aStream nextPutAll: each printString; space].
	aStream nextPutAll: ')'.! !

Warning subclass: #SixxWarning
	instanceVariableNames: 'className element context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

SixxWarning subclass: #SixxClassNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxClassNotFound methodsFor: 'exceptionDescription' stamp: 'MU 10/27/2002 19:39'!
description
	"Return a textual description of the exception."
	self className isNil ifTrue: [ ^super description , ': ', 'Type cannot be detected from XML'].
	^ super description , ': ' , self className! !

SixxWarning subclass: #SixxInvalidDeserialization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxInvalidDeserialization methodsFor: 'exceptionDescription' stamp: 'MU 10/27/2002 19:50'!
description
	"Return a textual description of the exception."
	^ super description , ': ' , self className printString! !

SixxWarning subclass: #SixxInvalidSerialization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxInvalidSerialization methodsFor: 'exceptionDescription' stamp: 'MU 10/27/2002 19:50'!
description
	"Return a textual description of the exception."
	^ super description , ': ' , self className printString! !

SixxWarning subclass: #SixxNewFailed
	instanceVariableNames: 'alternativeInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxWarning class methodsFor: 'instance creation' stamp: 'MU 10/27/2002 17:23'!
signal: className
	^self signal: className context: nil ! !

!SixxWarning class methodsFor: 'instance creation' stamp: 'MU 10/27/2002 17:23'!
signal: className context: dictionary 
	^self signal: className element: nil context: dictionary ! !

!SixxWarning class methodsFor: 'instance creation' stamp: 'MU 10/27/2002 17:27'!
signal: className element: xmlElement 
	^self signal: className element: xmlElement context: nil ! !

!SixxWarning class methodsFor: 'instance creation' stamp: 'MU 10/26/2002 01:35'!
signal: className element: xmlElement context: dictionary 
	| inst |
	inst := self new.
	inst className: className.
	inst element: xmlElement.
	inst context: dictionary.
	^ inst signal! !

!SixxWarning methodsFor: 'accessing' stamp: 'MU 10/26/2002 01:35'!
className

	^className! !

!SixxWarning methodsFor: 'accessing' stamp: 'MU 10/26/2002 01:35'!
className: aValue

	className := aValue! !

!SixxWarning methodsFor: 'accessing' stamp: 'MU 10/26/2002 01:35'!
context

	^context! !

!SixxWarning methodsFor: 'accessing' stamp: 'MU 10/26/2002 01:35'!
context: aValue

	context := aValue! !

!SixxWarning methodsFor: 'exceptionDescription' stamp: 'MU 10/26/2002 01:35'!
defaultAction
	Transcript cr; show: '#warning# ' , self description.
	self resume! !

!SixxWarning methodsFor: 'accessing' stamp: 'MU 10/26/2002 01:35'!
element
	^ element! !

!SixxWarning methodsFor: 'accessing' stamp: 'MU 10/26/2002 01:35'!
element: aValue 
	element := aValue! !

!String class methodsFor: '*sixx-instance creation' stamp: 'kuri-t 5/15/2002 18:07'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ SixxXmlUtil characterDataFrom: sixxElement! !

!String methodsFor: '*sixx-printing' stamp: 'MU 9/16/2002 20:04'!
sixxContentOn: aStream indent: level context: dictionary
	SixxXmlUtil writeXmlText: self on: aStream! !

!String methodsFor: '*sixx-private' stamp: 'mu 2/7/2006 21:11'!
sixxType
	^#String! !

!AbstractFont class methodsFor: '*sixx-instance creation' stamp: 'mu 12/12/2006 23:35'!
createInstanceOf: aClass withSixxElement: sixxElement 

	"For old format"
	| stream space familyName size emphasisCode |
	(SixxXmlUtil elementsFrom: sixxElement ) isEmpty ifFalse: [
		^super createInstanceOf: aClass withSixxElement: sixxElement
	].

	stream := ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement).
	space := Character space.
	familyName := stream upTo: space.
	size := (stream upTo: space) asInteger.
	emphasisCode := (stream upTo: space) asInteger.
	^self familyName: familyName size: size emphasized: emphasisCode.
! !

!AbstractFont methodsFor: '*sixx-printing' stamp: 'mu 12/12/2006 23:34'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxContentString! !

!AbstractFont methodsFor: '*sixx-printing' stamp: 'mu 12/12/2006 23:33'!
sixxContentString
	"Squeak Specific"
	^self fontNameWithPointSize, ' ', self emphasis asString! !

!ContextPart class methodsFor: '*sixx-instance creation' stamp: 'MU 10/27/2002 17:35'!
createInstanceOf: aClass withSixxElement: sixxElement 
	SixxInvalidDeserialization signal: aClass name element: sixxElement. 
	^nil! !

!ContextPart methodsFor: '*sixx-printing' stamp: 'MU 10/27/2002 17:24'!
sixxContentOn: aStream indent: level context: dictionary
	SixxInvalidSerialization signal: self class name context: dictionary.
	aStream nextPutAll: self printString! !

!Behavior methodsFor: '*sixx-private' stamp: 'mu 6/7/2007 19:15'!
classFromSixxElement: sixxElement context: dictionary 
	|  type env resolver retClass |
	type := self typeFromSixxElement: sixxElement.
	type isNil ifTrue: [^ nil].

	env := self envFromSixxElement: sixxElement.
	resolver := dictionary at: #'SixxContextValue::CustomClassResolver' ifAbsent: [SixxClassResolver default].
	retClass :=  resolver classAt: type in: env.

	^ retClass isNil
		ifTrue: [SixxClassNotFound
				signal: type
				element: sixxElement
				context: dictionary]
		ifFalse: [retClass]! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'mu 6/25/2004 03:25'!
createInstanceOf: aClass withSixxElement: sixxElement 
	"override if you like"
	^ aClass isVariable
		ifTrue: [self createMixedFieldsInstanceOf: aClass withSixxElement: sixxElement]
		ifFalse: [self sixxNew: aClass withSixxElement: sixxElement]! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'mu 6/25/2004 03:25'!
createMixedFieldsInstanceOf: aClass withSixxElement: sixxElement 
	"override if you like"
	| nonameElems size |
	nonameElems := (SixxXmlUtil elementsFrom: sixxElement)
				select: [:each | (self nameFromSixxElement: each) isNil].
	size := nonameElems isEmpty
				ifTrue: [0]
				ifFalse: [nonameElems size].
	^ self
		sixxNew: aClass
		size: size
		withSixxElement: sixxElement! !

!Behavior methodsFor: '*sixx-private' stamp: 'mu 3/29/2007 23:15'!
envFromSixxElement: sixxElement 
	^SixxXmlUtil attributeSymbolAt: SixxConstants current envTagName from: sixxElement.! !

!Behavior methodsFor: '*sixx-private' stamp: 'MU 5/31/2002 15:21'!
fromSixxElement: sixxElement context: aDictionary 
	^ (self includesRefInstanceFromSixxElement: sixxElement context: aDictionary)
		ifTrue: [self refInstanceFromSixxElement: sixxElement context: aDictionary]
		ifFalse: [self newInstanceFromSixxElement: sixxElement context: aDictionary]! !

!Behavior methodsFor: '*sixx-private' stamp: 'mu 4/8/2007 19:49'!
idFromSixxElement: sixxElement 
	| sixxKey |
	sixxKey := SixxXmlUtil attributeSymbolAt: SixxConstants current idTagName from: sixxElement.
	^sixxKey isNil ifTrue: [''] ifFalse: [sixxKey]! !

!Behavior methodsFor: '*sixx-private' stamp: 'mu 3/29/2007 23:14'!
idrefFromSixxElement: sixxElement
	^SixxXmlUtil attributeSymbolAt: SixxConstants current idrefTagName from: sixxElement.
	! !

!Behavior methodsFor: '*sixx-private' stamp: 'kuri-t 6/3/2002 16:06'!
includesRefInstanceFromSixxElement: sixxElement context: aDictionary 
	| idref |
	idref := self idrefFromSixxElement: sixxElement.
	^ idref isNil
		ifTrue: [false]
		ifFalse: [aDictionary includesKey: idref]! !

!Behavior methodsFor: '*sixx-private' stamp: 'mu 3/29/2007 23:13'!
nameFromSixxElement: sixxElement 
	^SixxXmlUtil attributeSymbolAt: SixxConstants current nameTagName from: sixxElement.
	! !

!Behavior methodsFor: '*sixx-private' stamp: 'mu 2/9/2007 10:29'!
newInstanceFromSixxElement: sixxElement context: aDictionary 
	| class inst elemId |
	class := self classFromSixxElement: sixxElement context: aDictionary .
	class isNil
		ifTrue: [class := SixxClassNotFound
				signal: (self typeFromSixxElement: sixxElement)
				element: sixxElement
				context: aDictionary].
	class ifNil: [^nil].
	inst := class createInstanceOf: class withSixxElement: sixxElement.
	elemId := self idFromSixxElement: sixxElement.
	aDictionary	at: elemId put: inst.
	inst initializeFromSixxElement: sixxElement context: aDictionary.
	inst sixxInitialize.
	inst := inst sixxReadValue.
	aDictionary	at: elemId put: inst.
	^ inst! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'kuri-t 6/3/2002 16:29'!
readSixxFromSixxElement: sixxElement context: aDictionary 
	| rootClass typeAttr |
	typeAttr := self typeFromSixxElement: sixxElement.
	^typeAttr isNil
		ifTrue: [(self includesRefInstanceFromSixxElement: sixxElement context: aDictionary)
				ifTrue: [self refInstanceFromSixxElement: sixxElement context: aDictionary]]
		ifFalse: [rootClass := self classFromSixxElement: sixxElement context: aDictionary.
			rootClass isNil
				ifFalse: [rootClass fromSixxElement: sixxElement context: aDictionary]]! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'kuri-t 5/20/2002 14:05'!
readSixxFrom: xmlStringOrStream 
	^ self readSixxFrom: xmlStringOrStream context: IdentityDictionary new! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'kuri-t 5/20/2002 14:04'!
readSixxFrom: xmlStringOrStream context: aDictionary 
	| topElem |
	topElem := SixxXmlUtil parseXml: xmlStringOrStream.
	^ self readSixxFromSixxElement: topElem context: aDictionary! !

!Behavior methodsFor: '*sixx-private' stamp: 'mu 2/9/2007 10:20'!
refInstanceFromSixxElement: sixxElement context: aDictionary 
	| idref |
	idref := self idrefFromSixxElement: sixxElement.
	^aDictionary at: idref! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'mu 6/26/2004 16:21'!
sixxNew: aClass size: size withSixxElement: sixxElement 
	^ [aClass new: size]
		on: Error
		do: [:ex | 
			| alterClass | 
			alterClass := SixxNewFailed signal: aClass name element: sixxElement.
			alterClass isNil
				ifTrue: [[aClass basicNew: size] on: Error do: [self sixxNew: aClass withSixxElement: sixxElement ]]
				ifFalse: [alterClass basicNew: size]]! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'mu 6/24/2004 22:20'!
sixxNew: aClass withSixxElement: sixxElement 
	^[aClass new]
		on: Error
		do: [:ex | 
			| alterClass | 
			alterClass := SixxNewFailed signal: aClass name element: sixxElement.
			alterClass isNil
				ifTrue: [aClass basicNew]
				ifFalse: [alterClass basicNew]]! !

!Behavior methodsFor: '*sixx-private' stamp: 'mu 3/29/2007 23:14'!
typeFromSixxElement: sixxElement 
	^SixxXmlUtil attributeSymbolAt: SixxConstants current typeTagName from: sixxElement.
	! !

!FixedFaceFont methodsFor: '*sixx-printing' stamp: 'mu 12/12/2006 23:33'!
emphasis
	^0! !

Error subclass: #SixxError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

SixxError subclass: #SixxInvalidFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

Error subclass: #SixxXmlParseError
	instanceVariableNames: 'originalError'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxXmlParseError class methodsFor: 'instance creation' stamp: 'MU 5/24/2003 19:00'!
originalError: anError
	^self new originalError: anError! !

!SixxXmlParseError methodsFor: 'accessing' stamp: 'MU 5/24/2003 18:59'!
originalError
	^originalError! !

!SixxXmlParseError methodsFor: 'accessing' stamp: 'MU 5/24/2003 18:59'!
originalError: anError
	originalError := anError! !

!UndefinedObject class methodsFor: '*sixx-instance creation' stamp: 'mu 4/14/2007 12:00'!
createInstanceOf: aClass withSixxElement: sixxElement
	^nil! !

!UndefinedObject methodsFor: '*sixx-printing' stamp: 'mu 4/11/2007 10:57'!
sixxOn: aStream name: nameString indent: level context: dictionary 
	| constants |
	aStream tab: level.
	constants := SixxConstants current.
	aStream nextPutAll: ( SixxXmlUtil contentsWithEmptyTagNamed: constants objectTagName do: [:wStr |   
		SixxXmlUtil writeAttribute: constants nameTagName value: nameString on: wStr.
		SixxXmlUtil writeAttribute: constants typeTagName value: self sixxType on: wStr.
		SixxSettings useEnvironment 
			ifTrue: [SixxXmlUtil writeAttribute: constants envTagName value: self sixxEnv on: wStr.].
	]).
	aStream cr.! !

!DateAndTime class methodsFor: '*sixx-instance creation' stamp: 'mu 3/29/2007 22:34'!
createInstanceOf: aClass withSixxElement: sixxElement 

	"For old format"
	(SixxXmlUtil elementsFrom: sixxElement ) isEmpty ifFalse: [
		^super createInstanceOf: aClass withSixxElement: sixxElement
	].

	^ self readSixxContentStringFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!DateAndTime class methodsFor: '*sixx-private' stamp: 'mu 3/29/2007 22:34'!
readSixxContentStringFrom: aStream
	"Squeak specific"
	^ self readFrom: aStream! !

!DateAndTime methodsFor: '*sixx-printing' stamp: 'mu 7/20/2006 15:47'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxContentString! !

!DateAndTime methodsFor: '*sixx-private' stamp: 'mu 7/20/2006 15:47'!
sixxContentString
	"Squeak Specific"
	^self printString! !

!WordArray class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:21'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| col |
	col := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	^ col asWordArray! !

!WordArray methodsFor: '*sixx-printing' stamp: 'MU 6/29/2002 16:00'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: '#( '.
	self do:[:each | aStream nextPutAll: each printString; space].
	aStream nextPutAll: ')'.! !

!True class methodsFor: '*sixx-instance creation' stamp: 'mu 4/5/2007 11:14'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^true! !

!Fraction class methodsFor: '*sixx-instance creation' stamp: 'mu 5/4/2007 13:19'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ self readSixxContentStringFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))
	! !

!Fraction class methodsFor: '*sixx-private' stamp: 'mu 5/4/2007 13:27'!
readSixxContentStringFrom: aStream
	| numerator denominator |
	aStream next. "skip $("
	numerator := aStream upTo: $/ .
	denominator := aStream upTo: $).

	^ self numerator: numerator asNumber denominator: denominator asNumber! !

!ShortPointArray class methodsFor: '*sixx-instance creation' stamp: 'mu 6/25/2004 21:28'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| rawCol points index pointStream |
	rawCol := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	rawCol := rawCol reject: [:e | e == #@].
	points := (Array new: rawCol size //2).
	index := 1.
	pointStream _  rawCol readStream.
	[pointStream atEnd] whileFalse: [
		points at: index put: (Point x: pointStream next asNumber y: pointStream next asNumber).
		index := index + 1.
	].
	
	^self withAll: points! !

!TTCFontSet class methodsFor: '*sixx-instance creation' stamp: 'mu 12/12/2006 23:38'!
familyName: aName size: aSize emphasized: emphasisCode
	^self familyName: aName pointSize: aSize emphasis: emphasisCode! !

!False class methodsFor: '*sixx-instance creation' stamp: 'mu 4/5/2007 11:14'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^false! !

!ArrayedCollection methodsFor: '*sixx-initializing' stamp: 'mu 6/25/2004 03:44'!
initializeFromSixxElement: sixxElement context: aDictionary 
	"override to use #initializeMixedFieldsFromSixxElement:context: if having some inst vars"
	| idx |
	idx := 1.
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | childInst | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [childInst := self class fromSixxElement: elem context: aDictionary.
					self at: idx put: childInst.
					idx := idx + 1]]! !

!Rectangle class methodsFor: '*sixx-instance creation' stamp: 'mu 12/12/2006 19:38'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| readStr origin corner |

	"For old format"
	(SixxXmlUtil elementsFrom: sixxElement ) isEmpty ifFalse: [
		^super createInstanceOf: aClass withSixxElement: sixxElement
	].

	readStr := ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement).
	origin := ((readStr upTo: $@) asNumber) @ (readStr upTo: Character space) asNumber.
	readStr upToAll: 'corner: '.
	corner := ((readStr upTo: $@) asNumber) @ (readStr upToEnd) asNumber.
	^origin corner: corner
! !

!Rectangle methodsFor: '*sixx-printing' stamp: 'mu 12/12/2006 19:31'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: self printString.
	! !

!Text methodsFor: '*sixx-initializing' stamp: 'MU 7/21/2002 23:35'!
initializeFromSixxElement: sixxElement context: aDictionary 
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | varName | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [varName := self class nameFromSixxElement: elem.
					varName notNil
						ifTrue: [| childInst | 
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst ]]]! !

!Text methodsFor: '*sixx-printing' stamp: 'mu 11/10/2006 14:12'!
sixxContentOn: aStream indent: level context: dictionary
	self sixxChildrenContentsOn: aStream indent: level + 1 context: dictionary.
	aStream tab: level.! !

!Character class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:17'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!Character methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:37'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString
	! !

!Collection class methodsFor: '*sixx-instance creation' stamp: 'mu 6/25/2004 03:32'!
createInstanceOf: aClass withSixxElement: sixxElement 
	"override to use #createMixedFieldsInstanceOf:withSixxElement: if you have extra inst vars"
	^ self
		sixxNew: aClass
		size: (SixxXmlUtil elementsFrom: sixxElement) size
		withSixxElement: sixxElement! !

!Collection methodsFor: '*sixx-initializing' stamp: 'mu 6/25/2004 03:59'!
initializeFromSixxElement: sixxElement context: aDictionary 
	"override to use #initializeMixedFieldsFromSixxElement:context: if having some inst vars"
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | 
			| childInst | 
			childInst := self class fromSixxElement: elem context: aDictionary.
			self add: childInst]! !

!Collection methodsFor: '*sixx-printing' stamp: 'mu 8/22/2007 19:26'!
sixxContentOn: aStream indent: level context: dictionary
	"default just uses #do: - override it to use #sixxAllFieldsOn:indent:context: if your collection need to store some inst vars"
	self isEmpty ifFalse: [aStream cr].
	self
		do: [:each | each
				sixxOn: aStream
				indent: level + 1
				context: dictionary].
	self isEmpty ifFalse: [aStream tab: level].! !

!Collection methodsFor: '*sixx-private' stamp: 'mu 6/25/2004 04:55'!
sixxIndexFieldsOn: aStream indent: level context: dictionary
	self size = 0 ifTrue: [^self].
	aStream cr.
	self do: 
			[:each | 
			each 
				sixxOn: aStream
				indent: level
				context: dictionary]

! !

!Collection methodsFor: '*sixx-private' stamp: 'mu 6/25/2004 04:55'!
sixxMixedFieldsOn: aStream indent: level context: dictionary
	"override"
	"Usually Collection's inst vars are not needed for serialization"
	self sixxIndexFieldsOn: aStream indent: level context: dictionary.! !

!Metaclass methodsFor: '*sixx-instance creation' stamp: 'MU 9/2/2002 02:46'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ aClass isMeta
		ifTrue: [aClass soleInstance]
		ifFalse: [aClass]! !

!Integer class methodsFor: '*sixx-instance creation' stamp: 'mu 6/26/2004 10:25'!
readShortHexFrom: aStream 
	| digit value startPos |
	value := 0.
	startPos := aStream position.
	[aStream atEnd]
		whileFalse: 
			[digit := aStream next digitValue.
			(digit < 0 or: [digit >= 16])
				ifTrue: 
					[aStream skip: -1.
					aStream position = startPos ifTrue: [self error: 'At least one digit expected here'].
					^ value]
				ifFalse: [value := value * 16 + digit]].
	^ value! !

!Integer methodsFor: '*sixx-printing' stamp: 'mu 6/26/2004 12:11'!
shortHexString
	| current letters digits quo i |
	digits := '0123456789ABCDEF'.
	current := self.
	i := self digitLength * 8.
	letters := String new: i.
	[current < 16] whileFalse: 
		[quo := current quo: 16.
		letters at: i put: (digits at: (current - (quo * 16)) + 1).
		i := i - 1.
		current := quo].
	letters at: i put: (digits at: current + 1).
	^letters copyFrom: i to: letters size! !

Array variableSubclass: #SixxMockMementoArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockMementoArray methodsFor: 'sixx-reading' stamp: 'mu 12/13/2006 23:09'!
sixxReadValue
	| inst |
	inst := SixxMockCustomWriteObject new.
	inst name: (self at: 1).
	inst time: (self at: 2).
	^inst! !

Array variableSubclass: #SixxMockVariableNewFailedClass
	instanceVariableNames: 'att1 att2 att3Block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

SixxMockVariableNewFailedClass variableSubclass: #SixxMockVariableAlternativeClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockVariableAlternativeClass class methodsFor: 'instance creation' stamp: 'mu 6/24/2004 23:06'!
new: size
	"new: is OK for me"
	^self basicNew: size! !

!SixxMockVariableNewFailedClass class methodsFor: 'instance creation-sixx' stamp: 'mu 6/25/2004 03:32'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^self createMixedFieldsInstanceOf: aClass withSixxElement: sixxElement ! !

!SixxMockVariableNewFailedClass class methodsFor: 'instance creation' stamp: 'mu 6/24/2004 23:12'!
new: size
	Error new signal: '#new: should not be called'! !

!SixxMockVariableNewFailedClass class methodsFor: 'for tests' stamp: 'mu 6/25/2004 00:05'!
prototype1
	"self prototype1"
	| inst |
	inst := self basicNew: 3.
	1 to: 3 do: [:idx | inst at: idx put: idx printString].
	inst att1: 1.
	inst att2: 'TWO'.
	inst att3Block: [:this | 'is block'].
	^inst! !

!SixxMockVariableNewFailedClass class methodsFor: 'for tests' stamp: 'mu 6/25/2004 00:06'!
prototype2
	"self prototype2"
	| inst |
	inst := self basicNew: 3.
	1 to: 3 do: [:idx | inst at: idx put: idx printString].
	inst att1: 3.
	inst att2: 'Four'.
	inst att3Block: [:this :is | 'block2'].
	^inst! !

!SixxMockVariableNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/25/2004 00:04'!
att1
	^att1! !

!SixxMockVariableNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/25/2004 00:04'!
att1: aValue
	att1 := aValue! !

!SixxMockVariableNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/25/2004 00:05'!
att2
	^att2! !

!SixxMockVariableNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/25/2004 00:05'!
att2: aValue
	att2 := aValue! !

!SixxMockVariableNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/25/2004 00:05'!
att3Block
	^att3Block! !

!SixxMockVariableNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/25/2004 00:05'!
att3Block: aValue
	att3Block := aValue! !

!SixxMockVariableNewFailedClass methodsFor: 'initializing-sixx' stamp: 'mu 6/25/2004 03:45'!
initializeFromSixxElement: sixxElement context: aDictionary 
	self initializeMixedFieldsFromSixxElement: sixxElement context: aDictionary! !

!SixxMockVariableNewFailedClass methodsFor: 'private-sixx' stamp: 'mu 6/26/2004 16:45'!
sixxContentOn: aStream indent: level context: dictionary
	"override if you like"
	self sixxInstVarsOn: aStream indent: level context: dictionary.
	self sixxIndexFieldsOn: aStream indent: level context: dictionary.! !

!SixxMockVariableNewFailedClass methodsFor: 'initializing-sixx' stamp: 'mu 6/25/2004 00:04'!
sixxInitialize
	att3Block := [:a :b | a < b].! !
SixxClassResolver initialize!
SixxConstants initialize!
SixxCustomStoreLoadExample initialize!
SixxMockClassForUnitTest initialize!
SixxMockSuperClassForUnitTest initialize!
SixxAutoMorphMemento initialize!
SixxPortableUtil initialize!
SixxXmlUtil initialize!
